#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 19 "policy_parse.y"
#include <sys/types.h>
#include <stdint.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <sepol/policydb.h>
#include <sepol/services.h>
#include <sepol/conditional.h>
#include <sepol/flask.h>
#include "queue.h"
#include "checkpolicy.h"

/* 
 * We need the following so we have a valid error return code in yacc
 * when we have a parse error for a conditional rule.  We can't check 
 * for NULL (ie 0) because that is a potentially valid return.
 */
static cond_av_list_t *conditional_unused_error_code;
#define COND_ERR (cond_av_list_t *)&conditional_unused_error_code

#define TRUE 1
#define FALSE 0

policydb_t *policydbp;
queue_t id_queue = 0;
unsigned int pass;
char *curfile = 0;
unsigned int curline; 

extern unsigned long policydb_lineno;

extern char yytext[];
extern int yywarn(char *msg);
extern int yyerror(char *msg);

static char errormsg[255];

static int insert_separator(int push);
static int insert_id(char *id,int push);
static int define_class(void);
static int define_initial_sid(void);
static int define_common_perms(void);
static int define_av_perms(int inherits);
static int define_sens(void);
static int define_dominance(void);
static int define_category(void);
static int define_level(void);
static int define_common_base(void);
static int define_av_base(void);
static int define_attrib(void);
static int define_typealias(void);
static int define_type(int alias);
static int define_compute_type(int which);
static int define_te_avtab(int which);
static int define_role_types(void);
static role_datum_t *merge_roles_dom(role_datum_t *r1,role_datum_t *r2);
static role_datum_t *define_role_dom(role_datum_t *r);
static int define_role_trans(void);
static int define_role_allow(void);
static int define_constraint(constraint_expr_t *expr);
static int define_bool();
static int define_conditional(cond_expr_t *expr,cond_av_list_t *t_list, cond_av_list_t *f_list );
static cond_expr_t *define_cond_expr(uint32_t expr_type, void *arg1, void* arg2);
static cond_av_list_t *define_cond_pol_list(cond_av_list_t *avlist, cond_av_list_t *stmt);
static cond_av_list_t *define_cond_compute_type(int which);
static cond_av_list_t *define_cond_te_avtab(int which);
static cond_av_list_t *cond_list_append(cond_av_list_t *sl, avtab_key_t *key, avtab_datum_t *datum);
static void cond_reduce_insert_list(cond_av_list_t *new, cond_av_list_t **active, cond_av_list_t **inactive, int state ); 
static uintptr_t define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2);
static int define_user(void);
static int parse_security_context(context_struct_t *c);
static int define_initial_sid_context(void);
static int define_fs_use(int behavior);
static int define_genfs_context(int has_type);
static int define_fs_context(unsigned int major, unsigned int minor);
static int define_port_context(unsigned int low, unsigned int high);
static int define_netif_context(void);
static int define_ipv4_node_context(unsigned int addr, unsigned int mask);
static int define_ipv6_node_context(void);
#line 101 "policy_parse.y"
typedef union {
	unsigned int val;
	uintptr_t valptr;
	void *ptr;
} YYSTYPE;
#line 104 "y.tab.c"
#define YYERRCODE 256
#define PATH 257
#define CLONE 258
#define COMMON 259
#define CLASS 260
#define CONSTRAIN 261
#define INHERITS 262
#define SID 263
#define ROLE 264
#define ROLES 265
#define TYPEALIAS 266
#define TYPE 267
#define TYPES 268
#define ALIAS 269
#define ATTRIBUTE 270
#define BOOL 271
#define IF 272
#define ELSE 273
#define TYPE_TRANSITION 274
#define TYPE_MEMBER 275
#define TYPE_CHANGE 276
#define ROLE_TRANSITION 277
#define SENSITIVITY 278
#define DOMINANCE 279
#define DOM 280
#define DOMBY 281
#define INCOMP 282
#define CATEGORY 283
#define LEVEL 284
#define RANGES 285
#define USER 286
#define NEVERALLOW 287
#define ALLOW 288
#define AUDITALLOW 289
#define AUDITDENY 290
#define DONTAUDIT 291
#define SOURCE 292
#define TARGET 293
#define SAMEUSER 294
#define FSCON 295
#define PORTCON 296
#define NETIFCON 297
#define NODECON 298
#define FSUSEXATTR 299
#define FSUSETASK 300
#define FSUSETRANS 301
#define GENFSCON 302
#define U1 303
#define U2 304
#define R1 305
#define R2 306
#define T1 307
#define T2 308
#define NOT 309
#define AND 310
#define OR 311
#define XOR 312
#define CTRUE 313
#define CFALSE 314
#define IDENTIFIER 315
#define USER_IDENTIFIER 316
#define NUMBER 317
#define EQUALS 318
#define NOTEQUAL 319
#define IPV6_ADDR 320
const short yylhs[] = {                                        -1,
   23,   28,    0,   19,   19,   33,   20,   20,   35,   21,
   36,   36,   38,   38,   39,   37,   37,   41,   41,   41,
   22,   22,   42,   43,   43,   48,   48,   49,   44,   44,
   45,   45,   51,   51,   52,   52,   46,   46,   53,   53,
   47,   55,   55,   57,   57,   58,   56,   56,   60,   60,
   59,   59,   61,   61,   24,   24,   62,   62,   62,   64,
   64,   64,   64,   63,   63,   63,   63,   63,   63,   63,
   69,   70,   70,   71,   76,   76,   72,   77,   77,   75,
   75,   75,   75,   75,   75,    1,    1,    1,    1,    1,
    1,    1,    1,    2,    3,    3,   10,   10,    8,    8,
    8,    9,    9,    9,    9,    4,    5,    6,    7,   73,
   73,   73,   74,   74,   74,   74,   74,   78,   79,   80,
   81,   82,   65,   66,   67,   68,   12,   12,   11,   11,
   26,   26,   84,   84,   85,   13,   13,   13,   13,   13,
   14,   14,   14,   87,   14,   88,   14,   90,   14,   91,
   14,   92,   14,   93,   14,   14,   94,   14,   95,   14,
   14,   96,   14,   97,   14,   15,   15,   16,   16,   16,
   16,   25,   25,   99,   99,   98,  101,  101,  102,  102,
  104,  104,   27,   27,  105,   29,   29,  107,  107,  108,
   32,  109,  109,  112,  112,  113,  113,  110,  110,  114,
  114,  115,  111,  111,  116,  116,  117,  117,   30,   30,
  119,  119,  119,   31,   31,  120,  120,  121,  123,  121,
  121,   17,  106,  124,  124,  103,  103,  125,  125,   54,
   54,  126,  127,   50,   50,   50,   50,   50,  129,   50,
  130,  131,   89,   89,   89,   89,   89,  132,  132,   83,
   40,   40,  128,  133,  133,  134,  135,  134,  134,   34,
  100,  136,  137,  137,  137,  137,   86,   86,   86,   86,
   86,  122,   18,  118,
};
const short yylen[] = {                                         2,
    0,    0,   14,    1,    2,    2,    1,    2,    2,    2,
    1,    0,    1,    2,    5,    1,    2,    5,    4,    7,
    1,    0,    5,    1,    2,    4,    3,    2,    2,    4,
    1,    0,    1,    2,    4,    3,    1,    2,    5,    3,
    2,    1,    0,    1,    2,    5,    1,    2,    5,    2,
    1,    2,    3,    5,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    3,    5,    4,    4,    2,    0,    4,    1,    1,    5,
    9,    8,    8,    7,    4,    3,    2,    3,    3,    3,
    3,    3,    1,    1,    1,    2,    1,    1,    7,    7,
    7,    1,    1,    1,    1,    7,    7,    7,    7,    7,
    7,    7,    1,    1,    1,    1,    1,    7,    7,    7,
    7,    7,    5,    4,    5,    4,    1,    2,    3,    5,
    1,    0,    1,    2,    5,    3,    2,    3,    3,    1,
    3,    3,    3,    0,    4,    0,    4,    0,    4,    0,
    4,    0,    4,    0,    4,    1,    0,    4,    0,    4,
    2,    0,    4,    0,    4,    1,    1,    1,    1,    1,
    1,    1,    2,    1,    1,    6,    2,    0,    1,    3,
    1,    2,    1,    2,    3,    1,    0,    1,    2,    5,
    3,    1,    0,    1,    2,    4,    6,    1,    0,    1,
    2,    4,    1,    0,    1,    2,    4,    4,    1,    2,
    4,    4,    4,    1,    0,    1,    2,    6,    0,    7,
    4,    7,    6,    2,    0,    3,    1,    3,    1,    1,
    3,    1,    1,    1,    1,    1,    2,    2,    0,    4,
    1,    1,    1,    3,    1,    2,    4,    1,    2,    1,
    1,    2,    3,    1,    2,    1,    0,    3,    1,    1,
    1,    1,    1,    2,    2,    2,    1,    1,    3,    2,
    4,    1,    1,    1,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    4,  260,    6,    0,    0,    5,    7,
    9,    0,    1,    8,    0,    0,   13,    0,    0,    0,
    0,   16,   14,    0,    0,    0,   21,    0,   24,    0,
   17,  251,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   59,    0,   55,   57,   58,   60,   61,   62,   63,   64,
   65,   66,   67,   68,   69,   70,  113,  114,  115,  116,
  117,    0,    0,   25,    0,    0,   15,  252,    0,   27,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   93,
   94,    0,  232,  233,    0,    0,    0,  236,  235,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   56,  172,    0,   29,    0,    0,    0,   33,    0,    0,
   28,   26,    0,    0,    0,    0,    0,   71,   78,   79,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  257,
  256,  259,    0,  254,  239,    0,  237,  238,    0,    0,
    0,    0,  127,    0,    0,    0,    0,    0,    0,  261,
  174,    0,  175,    0,    2,    0,  133,  173,    0,    0,
    0,    0,   37,   34,    0,   18,    0,   74,  230,    0,
    0,   73,   77,   86,    0,    0,    0,   91,   92,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  102,  103,
  104,  105,   97,   98,   95,    0,  253,  255,    0,    0,
    0,    0,    0,  250,    0,  124,  128,    0,  126,    0,
    0,    0,    0,    0,    0,    0,  134,   30,   36,    0,
    0,    0,   23,   38,    0,    0,   44,    0,  123,    0,
   72,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   96,  258,  240,    0,    0,    0,  125,    0,  129,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  183,   35,
   40,    0,    0,    0,    0,   47,   45,   20,  231,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  156,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  140,    0,    0,    0,  184,    0,  188,    0,
    0,    0,   48,    0,    0,    0,    0,    0,    0,    0,
   84,    0,    0,  110,  111,  112,  130,  122,  118,  119,
  120,  121,    0,    0,  177,  179,    0,  176,  169,  170,
  171,  166,  167,  168,  161,  157,  162,  159,  164,    0,
  146,    0,    0,  150,    0,  154,  137,    0,    0,    0,
  135,    0,  185,  273,    0,    0,    0,    0,    0,  209,
  189,   39,    0,    0,   51,    0,    0,    0,    0,    0,
    0,    0,    0,   83,   82,    0,  181,    0,    0,    0,
    0,    0,    0,    0,  141,    0,    0,    0,  142,    0,
  143,    0,    0,  136,  138,    0,    0,    0,    0,    0,
    0,    0,    0,  210,    0,  216,    0,   46,   52,    0,
    0,    0,    0,    0,    0,    0,    0,   81,  180,  182,
    0,  226,    0,  243,  158,  241,  242,    0,  245,  163,
  160,  165,  262,    0,  145,  267,    0,  268,  147,  149,
  151,  153,  155,    0,    0,    0,    0,    0,    0,    0,
    3,    0,    0,  194,  217,    0,   53,   49,   99,  100,
  101,  106,  107,  108,  109,  248,    0,    0,  246,    0,
  263,    0,    0,  270,    0,  190,  211,  212,  213,  272,
    0,    0,    0,    0,    0,  200,  195,    0,  244,  249,
    0,  264,  269,  265,  266,    0,    0,    0,    0,  221,
    0,    0,    0,  191,    0,  205,  201,   54,  247,  271,
    0,  223,  219,    0,    0,  196,    0,  274,    0,    0,
    0,  206,  224,    0,  218,    0,  202,    0,    0,    0,
  220,  197,  207,    0,  208,    0,    0,    0,  222,
};
const short yydgoto[] = {                                       2,
   89,   90,  198,  199,  200,  201,  202,  203,  204,  205,
  153,  154,  312,  313,  354,  355,  539,  540,    3,    8,
   13,   26,   19,   52,  110,  165,  268,  226,  316,  379,
  423,  471,    4,   95,   10,   15,   21,   16,   17,   33,
   22,   27,   28,   73,  116,  172,  233,   29,   81,   96,
  117,  118,  173,  180,  235,  275,  236,  237,  384,  276,
  385,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,   64,   65,   66,  127,  131,   67,   68,   69,
   70,   71,  444,  166,  167,  455,  406,  407,  456,  408,
  410,  412,  413,  401,  403,  402,  404,  112,  372,  163,
  299,  345,  346,  398,  269,  373,  318,  319,  472,  504,
  524,  473,  474,  505,  506,  525,  526,  541,  380,  425,
  426,  501,  544,  532,  347,   97,   98,   99,  209,  448,
  449,  487,  143,  144,  206,  458,  492,
};
const short yysindex[] = {                                   -213,
 -254,    0, -133,    0,    0,    0, -254, -138,    0,    0,
    0, -254,    0,    0, -191, -171,    0,  -23, -155, -254,
 -191,    0,    0, -254, -254,  619,    0, -106,    0,  -78,
    0,    0,  -98,  -47, -254, -254, -254, -254, -254,  -27,
  -20,  -20,  -20,  -20,   22,  -20,  -20,  -20,  -20,  -20,
    0,  499,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -97, -105,    0, -254, -254,    0,    0,  -20,    0,
  106,  -79,  -84,  -28,  138, -122,  -27,  -27,  -68,    0,
    0,   59,    0,    0,  164,  -20,  -94,    0,    0,  -20,
  -20,  -20,  -40,  -20,  -20,  -20,  -20,  -20, -117, -196,
    0,    0, -254,    0, -254,  -69, -105,    0,  103,  -83,
    0,    0,  -20,  175, -254,  192,  206,    0,    0,    0,
  213, -115,  -32,  -27,  -27,  -27,  -27,  -27,  -95,    0,
    0,    0,  -30,    0,    0,  223,    0,    0,  234,  236,
 -254,  -38,    0,  -76,  261,  148,  270,  271,  273,    0,
    0,   74,    0,  -20,    0,   83,    0,    0,  -77,  -34,
 -254, -175,    0,    0, -254,    0,  297,    0,    0,  317,
  304,    0,    0,    0, -115, -143, -162,    0,    0,  -20,
  -20,  -20,  -20,  -20,  -20,  -20,   92,  276,    0,    0,
    0,    0,    0,    0,    0, -254,    0,    0, -254,  -20,
  -20,  -20,  307,    0,  -16,    0,    0,  -20,    0,  -20,
  -20,  -20,  -20,  -20,  -20,  110,    0,    0,    0,  322,
  153, -254,    0,    0,  122,  125,    0,  -75,    0, -254,
    0,  -20,  -20,  -20,  -20,  -20,  -20,  -20,  277,  129,
    0,    0,    0, -254, -254, -254,    0,  -40,    0,  -20,
  -20,  -20,  -20,  -20,  123,  219, -254, -182,    0,    0,
    0, -254,  284, -254,  122,    0,    0,    0,    0,  355,
  367,  370,  374,  378,  384,  385,  302,  288,  386,  395,
  409,  -74,  412,  413,  415,  419,  420,  -92,  421, -118,
 -136, -109,    0,  -35,  -35, -118,  -35,  -35,  -35,  219,
  219,  -49,    0, -117,  127,  -54,    0,  170,    0,   73,
 -254,  350,    0,  -20,  -20,  -20,  -20,  -20,  -20,  -20,
    0,  406,  414,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -254,  423,    0,    0,  439,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  178,
    0,    0,  179,    0,  181,    0,    0,   12,  219,  219,
    0,  443,    0,    0,  127, -254, -254, -254,  -72,    0,
    0,    0,  445,  -63,    0, -254, -254, -254, -254,  -20,
  -20,  -20,  -20,    0,    0,  437,    0,  -57, -254, -254,
   17,   17,   17,   17,    0,  -41,  -41,   17,    0,   17,
    0,   17,   17,    0,    0,  196, -254, -117, -117, -117,
 -117, -254,  212,    0,  207,    0,  -90,    0,    0,  -55,
  451,  456,  457,  458,  460,  470,  475,    0,    0,    0,
  317,    0,  -38,    0,    0,    0,    0,  -82,    0,    0,
    0,    0,    0,   -7,    0,    0, -102,    0,    0,    0,
    0,    0,    0,  479, -117,  481,  482,  485,  281, -254,
    0,  249,  212,    0,    0, -254,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -46,  -38,    0,  -67,
    0,  -59,   -7,    0, -254,    0,    0,    0,    0,    0,
    9,  127, -254,  250,  249,    0,    0,  -45,    0,    0,
  -26,    0,    0,    0,    0,  -52,  -48,  495,    1,    0,
   11, -117, -134,    0,  250,    0,    0,    0,    0,    0,
 -254,    0,    0, -117,  127,    0, -117,    0,  127,  508,
  237,    0,    0, -117,    0, -117,    0, -117,  127, -117,
    0,    0,    0,  510,    0,  127,  513,  127,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,  300,    0,    0,
    0,    0,    0,    0,    0,  301,    0,    0,  647,    0,
  353,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  279,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  514,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  446,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  311,
    0,    0,    0,    0,    0,    0,  295,    0,  396,    0,
    0,    0,    0,    0,    0,  514,    0,    0,    0,    0,
    0,   23,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  334,    0,    0,    0,    0,
    0,  320,    0,    0,    0,    0,    0,    0,    0,  540,
    0,    0,    0,    0,   48,    3,   26,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  529,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  340,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  559,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  175,    0,    0,   79,    0,    0,
    0,    0,    0,    0,  675,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  105,    0,    0,
    0,  591,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   52,    0,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -25,
    0,   15,    0,    0,   21,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    2,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   51,    0,    0,    0,    0,
    0,    0,   14,    0,    7,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   94,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    4,   20,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  604,    8,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  161,    0,    0,
    0,    0,    0,    0,  606,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
  765,    0, -215,    0,    0,    0,    0,    0,    0, -180,
 -126,  347,   61,    0,  438,  315,   68,   40,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  607,   -1,  600,    0,    0,    0,  610,  -73,
  601,    0,    0,    0,    0,    0,    0,  617,   32,  391,
    0,  530,  474, -212,    0,    0,    0,  422,  262,  382,
 -308,  597,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  533,    0,    0,    0,    0,
    0,    0, -147,    0,  498,  254,    0,    0,  618,    0,
    0,    0,    0,    0,    0,    0,    0,  555,  560,    0,
    0,    0, -238,    0,  408,  455,    0,  359,    0,    0,
    0,    0,  218,    0,  174,    0,  167,  152,  319,    0,
  274,    0,    0,    0,  308,  578,  605,  -14,    0,   16,
    0, -334,    0,  557,    0,   78,  208,
};
#define YYTABLESIZE 1031
const short yytable[] = {                                       6,
   94,  215,  120,  199,  215,   11,  214,  198,  184,  371,
   18,   80,   88,  193,  140,  125,  144,  251,   30,  192,
  493,   94,   32,   34,  229,  113,   77,  217,   92,  197,
  343,   78,  476,   82,   83,   84,   85,   86,   91,  169,
  488,  176,  259,   89,   76,  533,    1,  228,  216,  278,
  337,  229,  414,  519,  139,  535,  148,  509,   94,  320,
    5,  428,  152,   87,  164,  513,   90,  439,   20,  478,
  114,  332,  529,  119,   32,  429,  530,  142,  509,  528,
  267,  454,  148,  232,   93,   91,   91,   12,   88,  109,
  141,  139,   92,  228,  207,  147,  229,  144,  529,   24,
  144,  238,   92,  140,  397,   93,  258,  161,  171,  139,
  229,   32,  315,  170,  124,  126,  240,  396,   78,  490,
   12,  429,   25,  179,    7,   89,    1,  356,  142,    7,
  357,  382,   91,   91,   91,   91,   91,  148,  228,  443,
  148,  141,   93,  152,  103,   87,  152,  134,   90,  213,
  227,  251,  228,  511,  358,  137,  138,  359,  516,  440,
  225,  349,  350,  351,  122,  217,  134,   78,  136,  231,
   88,   25,   72,   32,  137,  138,  229,  115,  190,  191,
  192,   92,  374,   75,   79,  538,  441,  152,  123,  152,
  129,  130,  193,  194,  195,  196,  128,    5,  160,  352,
  353,  230,  137,  138,  252,  220,  219,  253,  145,  227,
  272,  271,  214,  453,  171,  251,    5,    5,  228,  225,
    5,   79,    5,  152,    5,  175,  376,  377,  378,  422,
  273,    5,  214,  178,   79,  125,   78,    5,  279,    5,
   79,  134,  135,  136,  376,  377,  378,  214,  453,  137,
  138,    5,  289,  290,  291,  214,  453,    5,  311,    5,
  369,  370,  214,  453,  182,  314,  214,  453,  214,    5,
  179,  183,  322,  214,  453,  227,  214,  134,  135,  136,
  210,   87,  352,  353,    5,  137,  138,    5,  214,  144,
  144,  211,  543,  212,    5,  486,  344,  215,  215,  215,
  489,  199,  214,  214,  214,  198,  486,  214,  453,  489,
  193,  193,  161,   89,  229,    5,  192,  192,  218,  383,
  168,  369,  370,    5,  160,    5,  160,  221,  222,  148,
  223,  214,   87,   87,   87,  152,   90,   90,  224,  510,
  486,  344,  510,  164,  514,  486,  229,  229,  229,  229,
  229,  229,  229,  229,  375,  239,  228,   88,   88,   88,
  240,  139,  241,  510,  249,  257,  229,  229,  510,  514,
  367,  368,  267,    5,  419,  420,  421,  187,  187,  187,
  270,  274,  383,  232,  383,  431,  432,  433,  228,  228,
  228,  228,  228,  228,  228,  228,  344,  179,  344,  287,
  250,  288,  508,  186,  186,  186,  321,  298,  228,  228,
  333,   10,  324,  227,  418,  464,  161,  161,  161,  161,
  469,  457,  457,  225,  325,  477,  331,  326,  383,  415,
  416,  327,  100,  101,  102,  328,  104,  105,  106,  107,
  108,  329,  330,  374,  334,  227,  227,  227,  227,  227,
  227,  227,  227,  335,   19,  225,  225,  225,  225,  225,
  225,  225,  225,  161,  315,  227,  227,  336,  502,  121,
  338,  339,  386,  340,   32,  225,  225,  341,  342,  348,
  399,  405,  300,  400,  409,  234,  146,  234,  411,  234,
  149,  150,  151,  518,  155,  156,  157,  158,  159,  161,
  417,  522,  427,  234,  234,  369,   78,  470,  422,  479,
  301,  302,  303,  177,  480,  481,  482,  534,  483,  161,
  161,  304,  305,  306,  307,  308,  309,  310,  484,  344,
  394,  491,  161,  485,  494,  161,  495,  500,  395,  497,
  498,  521,  161,  499,  161,  503,  161,  523,  161,  190,
  191,  192,  531,  549,  225,  556,  538,   51,  558,   12,
   11,  438,   32,  193,  194,  195,  196,  512,  234,  515,
  491,  234,   76,  132,  546,  190,  191,  192,   31,   43,
  242,  243,  244,  245,  246,  247,  248,   85,  554,  193,
  194,  195,  196,  512,  515,  557,  131,  559,   75,   42,
  254,  255,  256,  204,  292,  203,  548,   14,  260,    9,
  261,  262,  263,  264,  265,  266,   10,   80,   10,   10,
  363,   31,   10,   10,   10,   23,   10,   10,   10,   10,
   10,   10,  280,  281,  282,  283,  284,  285,  286,   10,
   10,   10,   10,   10,   74,  234,  174,  430,  111,   50,
  293,  294,  295,  296,  297,   19,  323,  277,  181,   19,
  459,   19,   19,  227,  168,   19,   19,   19,  162,   19,
   19,   19,   19,   19,   19,  317,  381,   51,  527,  190,
  191,  192,   19,   19,   19,   19,   19,  190,  191,  192,
  507,  542,  550,  193,  194,  195,  196,  424,  475,  208,
  517,  193,  194,  195,  196,   22,    0,  442,    0,  234,
  190,  191,  192,    0,  387,  388,  389,  390,  391,  392,
  393,    0,    0,    0,  193,  194,  195,  196,    0,    0,
  234,    0,    0,   41,    0,    0,    0,  234,  234,  234,
    0,  360,  361,  362,  364,  365,  366,    0,  234,  234,
  234,  234,  234,  234,  234,    0,    0,    0,    0,    0,
  234,    0,   35,    0,   36,   37,    0,    0,   38,   39,
   40,    0,   41,   42,   43,   44,    0,   45,    0,    0,
  434,  435,  436,  437,  109,   46,   47,   48,   49,   50,
    0,    0,   85,    0,   85,   85,    0,    0,   85,   85,
   85,    0,   85,   85,   85,   85,    0,   85,    0,    0,
    0,    0,    0,    0,   85,   85,   85,   85,   85,   85,
    0,    0,   80,    0,   80,   80,    0,    0,   80,   80,
   80,    0,   80,   80,   80,   80,    0,   80,    0,    0,
    0,    0,    0,    0,   80,   80,   80,   80,   80,   80,
   50,  132,  133,    0,   50,    0,   50,   50,    0,    0,
   50,   50,   50,    0,   50,   50,   50,   50,    0,   50,
    0,    0,  465,  466,  467,  468,    0,   50,   50,   50,
   50,   50,   35,    0,   36,   37,    0,    0,   38,   39,
   40,    0,   41,   42,   43,   44,    0,   45,  185,  186,
  187,  188,  189,    0,    0,   46,   47,   48,   49,   50,
   22,    0,   22,   22,    0,    0,   22,   22,   22,  496,
   22,   22,   22,   22,    0,   22,    0,    0,    0,    0,
    0,    0,    0,   22,   22,   22,   22,   22,   41,    0,
   41,   41,    0,    0,   41,   41,   41,    0,   41,   41,
   41,   41,    0,   41,    0,  520,    0,    0,    0,    0,
    0,   41,   41,   41,   41,   41,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  536,  537,    0,  446,  446,
  446,  446,    0,  446,  446,  446,    0,  446,  545,  446,
  446,  547,    0,    0,    0,    0,    0,    0,  551,    0,
  552,    0,  553,    0,  555,  447,  447,  447,  447,    0,
  447,  447,  447,    0,  447,    0,  447,  447,  445,  450,
  451,  452,    0,    0,    0,  460,    0,  461,    0,  462,
  463,
};
const short yycheck[] = {                                       1,
   42,    0,   76,    0,  152,    7,    0,    0,   41,   59,
   12,   59,   40,    0,   45,   44,   42,  198,   20,    0,
  123,   42,   24,   25,   59,  123,  125,  154,  123,  125,
  123,   33,  123,   35,   36,   37,   38,   39,   40,  113,
  123,  125,   59,   41,  123,   45,  260,  125,  125,  125,
  125,    0,   41,   45,  123,   45,   42,  125,   42,  272,
  315,  125,   42,   41,  261,  125,   41,  125,  260,  125,
   72,  287,  125,   75,   76,  384,  125,   92,  125,  125,
  263,  123,   97,  259,  126,   87,   88,  259,   41,  286,
   92,   41,  123,    0,  125,   97,   45,  123,  125,  123,
  126,  175,  123,   45,  343,  126,  123,  109,  284,   59,
   59,  113,  295,  115,   83,   84,   44,  333,  120,  454,
  259,  430,  278,  125,  263,  123,  260,  264,  143,  263,
  267,   59,  134,  135,  136,  137,  138,  123,   45,  123,
  126,  143,  126,  123,  123,  123,  126,  310,  123,  151,
    0,  332,   59,  488,  264,  318,  319,  267,  493,  398,
    0,  280,  281,  282,   59,  292,  310,  169,  312,  171,
  123,  278,  279,  175,  318,  319,  125,  283,  274,  275,
  276,  123,  317,  262,  269,  320,  399,  264,  268,  264,
  313,  314,  288,  289,  290,  291,   59,  315,  316,  318,
  319,  170,  318,  319,  206,   58,   59,  209,   45,   59,
   58,   59,  315,  316,  284,  396,  315,  315,  125,   59,
  315,  269,  315,  264,  315,  123,  299,  300,  301,  302,
  232,  315,  315,   59,  269,   44,  238,  315,  240,  315,
  269,  310,  311,  312,  299,  300,  301,  315,  316,  318,
  319,  315,  254,  255,  256,  315,  316,  315,   40,  315,
  310,  311,  315,  316,   59,  267,  315,  316,  315,  315,
  272,   59,  274,  315,  316,  125,  315,  310,  311,  312,
   58,  309,  318,  319,  315,  318,  319,  315,  315,  315,
  316,   58,  531,   58,  315,  443,  298,  296,  297,  298,
  448,  298,  296,  297,  298,  298,  454,  315,  316,  457,
  297,  298,  314,  311,  263,  315,  297,  298,   58,  321,
  306,  310,  311,  315,  316,  315,  316,   58,   58,  315,
   58,  315,  310,  311,  312,  315,  311,  312,  265,  487,
  488,  343,  490,  261,  492,  493,  295,  296,  297,  298,
  299,  300,  301,  302,  315,   59,  263,  310,  311,  312,
   44,  311,   59,  511,  273,   59,  315,  316,  516,  517,
  310,  311,  263,  315,  376,  377,  378,  299,  300,  301,
   59,  260,  384,  259,  386,  387,  388,  389,  295,  296,
  297,  298,  299,  300,  301,  302,  398,  399,  400,  123,
  125,  273,  476,  299,  300,  301,  123,  285,  315,  316,
  123,   59,   58,  263,  375,  417,  418,  419,  420,  421,
  422,  406,  407,  263,   58,  427,  125,   58,  430,  369,
  370,   58,   42,   43,   44,   58,   46,   47,   48,   49,
   50,   58,   58,  317,   59,  295,  296,  297,  298,  299,
  300,  301,  302,   59,   59,  295,  296,  297,  298,  299,
  300,  301,  302,  465,  295,  315,  316,   59,  470,   79,
   59,   59,  123,   59,  476,  315,  316,   59,   59,   59,
   58,  304,  264,   45,  306,   40,   96,   42,  308,   44,
  100,  101,  102,  495,  104,  105,  106,  107,  108,  501,
   58,  503,   58,   58,   59,  310,  508,  296,  302,   59,
  292,  293,  294,  123,   59,   59,   59,  519,   59,  521,
  522,  303,  304,  305,  306,  307,  308,  309,   59,  531,
  125,  454,  534,   59,  457,  537,   58,  257,  125,   59,
   59,  502,  544,   59,  546,  297,  548,  298,  550,  274,
  275,  276,   58,   46,  164,   46,  320,   59,   46,  260,
  260,  125,  284,  288,  289,  290,  291,  490,  123,  492,
  493,  126,   59,  263,  535,  274,  275,  276,  284,  260,
  190,  191,  192,  193,  194,  195,  196,   59,  549,  288,
  289,  290,  291,  516,  517,  556,  263,  558,   59,  260,
  210,  211,  212,    0,  258,    0,  539,    8,  218,    3,
  220,  221,  222,  223,  224,  225,  264,   59,  266,  267,
  306,   21,  270,  271,  272,   16,  274,  275,  276,  277,
  278,  279,  242,  243,  244,  245,  246,  247,  248,  287,
  288,  289,  290,  291,   28,  172,  117,  386,   52,   59,
  260,  261,  262,  263,  264,  260,  275,  236,  126,  264,
  407,  266,  267,  166,  110,  270,  271,  272,  109,  274,
  275,  276,  277,  278,  279,  268,  318,   59,  505,  274,
  275,  276,  287,  288,  289,  290,  291,  274,  275,  276,
  473,  525,  541,  288,  289,  290,  291,  379,  425,  143,
  493,  288,  289,  290,  291,   59,   -1,  400,   -1,  264,
  274,  275,  276,   -1,  324,  325,  326,  327,  328,  329,
  330,   -1,   -1,   -1,  288,  289,  290,  291,   -1,   -1,
  285,   -1,   -1,   59,   -1,   -1,   -1,  292,  293,  294,
   -1,  304,  305,  306,  307,  308,  309,   -1,  303,  304,
  305,  306,  307,  308,  309,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  264,   -1,  266,  267,   -1,   -1,  270,  271,
  272,   -1,  274,  275,  276,  277,   -1,  279,   -1,   -1,
  390,  391,  392,  393,  286,  287,  288,  289,  290,  291,
   -1,   -1,  264,   -1,  266,  267,   -1,   -1,  270,  271,
  272,   -1,  274,  275,  276,  277,   -1,  279,   -1,   -1,
   -1,   -1,   -1,   -1,  286,  287,  288,  289,  290,  291,
   -1,   -1,  264,   -1,  266,  267,   -1,   -1,  270,  271,
  272,   -1,  274,  275,  276,  277,   -1,  279,   -1,   -1,
   -1,   -1,   -1,   -1,  286,  287,  288,  289,  290,  291,
  260,   87,   88,   -1,  264,   -1,  266,  267,   -1,   -1,
  270,  271,  272,   -1,  274,  275,  276,  277,   -1,  279,
   -1,   -1,  418,  419,  420,  421,   -1,  287,  288,  289,
  290,  291,  264,   -1,  266,  267,   -1,   -1,  270,  271,
  272,   -1,  274,  275,  276,  277,   -1,  279,  134,  135,
  136,  137,  138,   -1,   -1,  287,  288,  289,  290,  291,
  264,   -1,  266,  267,   -1,   -1,  270,  271,  272,  465,
  274,  275,  276,  277,   -1,  279,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  287,  288,  289,  290,  291,  264,   -1,
  266,  267,   -1,   -1,  270,  271,  272,   -1,  274,  275,
  276,  277,   -1,  279,   -1,  501,   -1,   -1,   -1,   -1,
   -1,  287,  288,  289,  290,  291,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  521,  522,   -1,  401,  402,
  403,  404,   -1,  406,  407,  408,   -1,  410,  534,  412,
  413,  537,   -1,   -1,   -1,   -1,   -1,   -1,  544,   -1,
  546,   -1,  548,   -1,  550,  401,  402,  403,  404,   -1,
  406,  407,  408,   -1,  410,   -1,  412,  413,  401,  402,
  403,  404,   -1,   -1,   -1,  408,   -1,  410,   -1,  412,
  413,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 320
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'",0,"','","'-'","'.'",0,0,0,0,0,0,0,0,0,0,0,"':'",
"';'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'","'~'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"PATH","CLONE","COMMON","CLASS","CONSTRAIN","INHERITS","SID","ROLE",
"ROLES","TYPEALIAS","TYPE","TYPES","ALIAS","ATTRIBUTE","BOOL","IF","ELSE",
"TYPE_TRANSITION","TYPE_MEMBER","TYPE_CHANGE","ROLE_TRANSITION","SENSITIVITY",
"DOMINANCE","DOM","DOMBY","INCOMP","CATEGORY","LEVEL","RANGES","USER",
"NEVERALLOW","ALLOW","AUDITALLOW","AUDITDENY","DONTAUDIT","SOURCE","TARGET",
"SAMEUSER","FSCON","PORTCON","NETIFCON","NODECON","FSUSEXATTR","FSUSETASK",
"FSUSETRANS","GENFSCON","U1","U2","R1","R2","T1","T2","NOT","AND","OR","XOR",
"CTRUE","CFALSE","IDENTIFIER","USER_IDENTIFIER","NUMBER","EQUALS","NOTEQUAL",
"IPV6_ADDR",
};
const char * const yyrule[] = {
"$accept : policy",
"$$1 :",
"$$2 :",
"policy : classes initial_sids access_vectors $$1 opt_mls te_rbac users opt_constraints $$2 initial_sid_contexts opt_fs_contexts fs_uses opt_genfs_contexts net_contexts",
"classes : class_def",
"classes : classes class_def",
"class_def : CLASS identifier",
"initial_sids : initial_sid_def",
"initial_sids : initial_sids initial_sid_def",
"initial_sid_def : SID identifier",
"access_vectors : opt_common_perms av_perms",
"opt_common_perms : common_perms",
"opt_common_perms :",
"common_perms : common_perms_def",
"common_perms : common_perms common_perms_def",
"common_perms_def : COMMON identifier '{' identifier_list '}'",
"av_perms : av_perms_def",
"av_perms : av_perms av_perms_def",
"av_perms_def : CLASS identifier '{' identifier_list '}'",
"av_perms_def : CLASS identifier INHERITS identifier",
"av_perms_def : CLASS identifier INHERITS identifier '{' identifier_list '}'",
"opt_mls : mls",
"opt_mls :",
"mls : sensitivities dominance opt_categories levels base_perms",
"sensitivities : sensitivity_def",
"sensitivities : sensitivities sensitivity_def",
"sensitivity_def : SENSITIVITY identifier alias_def ';'",
"sensitivity_def : SENSITIVITY identifier ';'",
"alias_def : ALIAS names",
"dominance : DOMINANCE identifier",
"dominance : DOMINANCE '{' identifier_list '}'",
"opt_categories : categories",
"opt_categories :",
"categories : category_def",
"categories : categories category_def",
"category_def : CATEGORY identifier alias_def ';'",
"category_def : CATEGORY identifier ';'",
"levels : level_def",
"levels : levels level_def",
"level_def : LEVEL identifier ':' id_comma_list ';'",
"level_def : LEVEL identifier ';'",
"base_perms : opt_common_base av_base",
"opt_common_base : common_base",
"opt_common_base :",
"common_base : common_base_def",
"common_base : common_base common_base_def",
"common_base_def : COMMON identifier '{' perm_base_list '}'",
"av_base : av_base_def",
"av_base : av_base av_base_def",
"av_base_def : CLASS identifier '{' perm_base_list '}'",
"av_base_def : CLASS identifier",
"perm_base_list : perm_base",
"perm_base_list : perm_base_list perm_base",
"perm_base : identifier ':' identifier",
"perm_base : identifier ':' '{' identifier_list '}'",
"te_rbac : te_rbac_decl",
"te_rbac : te_rbac te_rbac_decl",
"te_rbac_decl : te_decl",
"te_rbac_decl : rbac_decl",
"te_rbac_decl : ';'",
"rbac_decl : role_type_def",
"rbac_decl : role_dominance",
"rbac_decl : role_trans_def",
"rbac_decl : role_allow_def",
"te_decl : attribute_def",
"te_decl : type_def",
"te_decl : typealias_def",
"te_decl : bool_def",
"te_decl : transition_def",
"te_decl : te_avtab_def",
"te_decl : cond_stmt_def",
"attribute_def : ATTRIBUTE identifier ';'",
"type_def : TYPE identifier alias_def opt_attr_list ';'",
"type_def : TYPE identifier opt_attr_list ';'",
"typealias_def : TYPEALIAS identifier alias_def ';'",
"opt_attr_list : ',' id_comma_list",
"opt_attr_list :",
"bool_def : BOOL identifier bool_val ';'",
"bool_val : CTRUE",
"bool_val : CFALSE",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}'",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}' ELSE '{' cond_pol_list '}'",
"cond_stmt_def : IF cond_expr '{' cond_pol_list '}' ELSE '{' '}'",
"cond_stmt_def : IF cond_expr '{' '}' ELSE '{' cond_pol_list '}'",
"cond_stmt_def : IF cond_expr '{' '}' ELSE '{' '}'",
"cond_stmt_def : IF cond_expr '{' '}'",
"cond_expr : '(' cond_expr ')'",
"cond_expr : NOT cond_expr",
"cond_expr : cond_expr AND cond_expr",
"cond_expr : cond_expr OR cond_expr",
"cond_expr : cond_expr XOR cond_expr",
"cond_expr : cond_expr EQUALS cond_expr",
"cond_expr : cond_expr NOTEQUAL cond_expr",
"cond_expr : cond_expr_prim",
"cond_expr_prim : identifier",
"cond_pol_list : cond_rule_def",
"cond_pol_list : cond_pol_list cond_rule_def",
"cond_rule_def : cond_transition_def",
"cond_rule_def : cond_te_avtab_def",
"cond_transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"cond_transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"cond_transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"cond_te_avtab_def : cond_allow_def",
"cond_te_avtab_def : cond_auditallow_def",
"cond_te_avtab_def : cond_auditdeny_def",
"cond_te_avtab_def : cond_dontaudit_def",
"cond_allow_def : ALLOW names names ':' names names ';'",
"cond_auditallow_def : AUDITALLOW names names ':' names names ';'",
"cond_auditdeny_def : AUDITDENY names names ':' names names ';'",
"cond_dontaudit_def : DONTAUDIT names names ':' names names ';'",
"transition_def : TYPE_TRANSITION names names ':' names identifier ';'",
"transition_def : TYPE_MEMBER names names ':' names identifier ';'",
"transition_def : TYPE_CHANGE names names ':' names identifier ';'",
"te_avtab_def : allow_def",
"te_avtab_def : auditallow_def",
"te_avtab_def : auditdeny_def",
"te_avtab_def : dontaudit_def",
"te_avtab_def : neverallow_def",
"allow_def : ALLOW names names ':' names names ';'",
"auditallow_def : AUDITALLOW names names ':' names names ';'",
"auditdeny_def : AUDITDENY names names ':' names names ';'",
"dontaudit_def : DONTAUDIT names names ':' names names ';'",
"neverallow_def : NEVERALLOW names names ':' names names ';'",
"role_type_def : ROLE identifier TYPES names ';'",
"role_dominance : DOMINANCE '{' roles '}'",
"role_trans_def : ROLE_TRANSITION names names identifier ';'",
"role_allow_def : ALLOW names names ';'",
"roles : role_def",
"roles : roles role_def",
"role_def : ROLE identifier_push ';'",
"role_def : ROLE identifier_push '{' roles '}'",
"opt_constraints : constraints",
"opt_constraints :",
"constraints : constraint_def",
"constraints : constraints constraint_def",
"constraint_def : CONSTRAIN names names cexpr ';'",
"cexpr : '(' cexpr ')'",
"cexpr : NOT cexpr",
"cexpr : cexpr AND cexpr",
"cexpr : cexpr OR cexpr",
"cexpr : cexpr_prim",
"cexpr_prim : U1 op U2",
"cexpr_prim : R1 roleop R2",
"cexpr_prim : T1 op T2",
"$$3 :",
"cexpr_prim : U1 op $$3 user_names_push",
"$$4 :",
"cexpr_prim : U2 op $$4 user_names_push",
"$$5 :",
"cexpr_prim : R1 op $$5 names_push",
"$$6 :",
"cexpr_prim : R2 op $$6 names_push",
"$$7 :",
"cexpr_prim : T1 op $$7 names_push",
"$$8 :",
"cexpr_prim : T2 op $$8 names_push",
"cexpr_prim : SAMEUSER",
"$$9 :",
"cexpr_prim : SOURCE ROLE $$9 names_push",
"$$10 :",
"cexpr_prim : TARGET ROLE $$10 names_push",
"cexpr_prim : ROLE roleop",
"$$11 :",
"cexpr_prim : SOURCE TYPE $$11 names_push",
"$$12 :",
"cexpr_prim : TARGET TYPE $$12 names_push",
"op : EQUALS",
"op : NOTEQUAL",
"roleop : op",
"roleop : DOM",
"roleop : DOMBY",
"roleop : INCOMP",
"users : user_def",
"users : users user_def",
"user_id : identifier",
"user_id : user_identifier",
"user_def : USER user_id ROLES names opt_user_ranges ';'",
"opt_user_ranges : RANGES user_ranges",
"opt_user_ranges :",
"user_ranges : mls_range_def",
"user_ranges : '{' user_range_def_list '}'",
"user_range_def_list : mls_range_def",
"user_range_def_list : user_range_def_list mls_range_def",
"initial_sid_contexts : initial_sid_context_def",
"initial_sid_contexts : initial_sid_contexts initial_sid_context_def",
"initial_sid_context_def : SID identifier security_context_def",
"opt_fs_contexts : fs_contexts",
"opt_fs_contexts :",
"fs_contexts : fs_context_def",
"fs_contexts : fs_contexts fs_context_def",
"fs_context_def : FSCON number number security_context_def security_context_def",
"net_contexts : opt_port_contexts opt_netif_contexts opt_node_contexts",
"opt_port_contexts : port_contexts",
"opt_port_contexts :",
"port_contexts : port_context_def",
"port_contexts : port_contexts port_context_def",
"port_context_def : PORTCON identifier number security_context_def",
"port_context_def : PORTCON identifier number '-' number security_context_def",
"opt_netif_contexts : netif_contexts",
"opt_netif_contexts :",
"netif_contexts : netif_context_def",
"netif_contexts : netif_contexts netif_context_def",
"netif_context_def : NETIFCON identifier security_context_def security_context_def",
"opt_node_contexts : node_contexts",
"opt_node_contexts :",
"node_contexts : node_context_def",
"node_contexts : node_contexts node_context_def",
"node_context_def : NODECON ipv4_addr_def ipv4_addr_def security_context_def",
"node_context_def : NODECON ipv6_addr ipv6_addr security_context_def",
"fs_uses : fs_use_def",
"fs_uses : fs_uses fs_use_def",
"fs_use_def : FSUSEXATTR identifier security_context_def ';'",
"fs_use_def : FSUSETASK identifier security_context_def ';'",
"fs_use_def : FSUSETRANS identifier security_context_def ';'",
"opt_genfs_contexts : genfs_contexts",
"opt_genfs_contexts :",
"genfs_contexts : genfs_context_def",
"genfs_contexts : genfs_contexts genfs_context_def",
"genfs_context_def : GENFSCON identifier path '-' identifier security_context_def",
"$$13 :",
"genfs_context_def : GENFSCON identifier path '-' '-' $$13 security_context_def",
"genfs_context_def : GENFSCON identifier path security_context_def",
"ipv4_addr_def : number '.' number '.' number '.' number",
"security_context_def : user_id ':' identifier ':' identifier opt_mls_range_def",
"opt_mls_range_def : ':' mls_range_def",
"opt_mls_range_def :",
"mls_range_def : mls_level_def '-' mls_level_def",
"mls_range_def : mls_level_def",
"mls_level_def : identifier ':' id_comma_list",
"mls_level_def : identifier",
"id_comma_list : identifier",
"id_comma_list : id_comma_list ',' identifier",
"tilde : '~'",
"asterisk : '*'",
"names : identifier",
"names : nested_id_set",
"names : asterisk",
"names : tilde identifier",
"names : tilde nested_id_set",
"$$14 :",
"names : identifier '-' $$14 identifier",
"tilde_push : tilde",
"asterisk_push : asterisk",
"names_push : identifier_push",
"names_push : '{' identifier_list_push '}'",
"names_push : asterisk_push",
"names_push : tilde_push identifier_push",
"names_push : tilde_push '{' identifier_list_push '}'",
"identifier_list_push : identifier_push",
"identifier_list_push : identifier_list_push identifier_push",
"identifier_push : IDENTIFIER",
"identifier_list : identifier",
"identifier_list : identifier_list identifier",
"nested_id_set : '{' nested_id_list '}'",
"nested_id_list : nested_id_element",
"nested_id_list : nested_id_list nested_id_element",
"nested_id_element : identifier",
"$$15 :",
"nested_id_element : '-' $$15 identifier",
"nested_id_element : nested_id_set",
"identifier : IDENTIFIER",
"user_identifier : USER_IDENTIFIER",
"user_identifier_push : USER_IDENTIFIER",
"user_identifier_list_push : user_identifier_push",
"user_identifier_list_push : identifier_list_push user_identifier_push",
"user_identifier_list_push : user_identifier_list_push identifier_push",
"user_identifier_list_push : user_identifier_list_push user_identifier_push",
"user_names_push : names_push",
"user_names_push : user_identifier_push",
"user_names_push : '{' user_identifier_list_push '}'",
"user_names_push : tilde_push user_identifier_push",
"user_names_push : tilde_push '{' user_identifier_list_push '}'",
"path : PATH",
"number : NUMBER",
"ipv6_addr : IPV6_ADDR",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 730 "policy_parse.y"
#define DEBUG 1

static int insert_separator(int push)
{
	int error;

	if (push)
		error = queue_push(id_queue, 0);
	else
		error = queue_insert(id_queue, 0);

	if (error) {
		yyerror("queue overflow");
		return -1;
	}
	return 0;
}

static int insert_id(char *id, int push)
{
	char *newid = 0;
	int error;

	newid = (char *) malloc(strlen(id) + 1);
	if (!newid) {
		yyerror("out of memory");
		return -1;
	}
	strcpy(newid, id);
	if (push)
		error = queue_push(id_queue, (queue_element_t) newid);
	else
		error = queue_insert(id_queue, (queue_element_t) newid);

	if (error) {
		yyerror("queue overflow");
		free(newid);
		return -1;
	}
	return 0;
}


static int define_class(void)
{
	char *id = 0;
	class_datum_t *datum = 0;
	int ret;


	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no class name for class definition?");
		return -1;
	}
	datum = (class_datum_t *) malloc(sizeof(class_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(class_datum_t));
	datum->value = ++policydbp->p_classes.nprim;

	ret = hashtab_insert(policydbp->p_classes.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_classes.nprim;
		yyerror("duplicate class definition");
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}
	return 0;

      bad:
	if (id)
		free(id);
	if (datum)
		free(datum);
	return -1;
}

static int define_initial_sid(void)
{
	char *id = 0;
	ocontext_t *newc = 0, *c, *head;


	if (pass == 2) {
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID definition?");
		return -1;
	}
	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		goto bad;
	}
	memset(newc, 0, sizeof(ocontext_t));
	newc->u.name = id;
	context_init(&newc->context[0]);
	head = policydbp->ocontexts[OCON_ISID];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate initial SID %s", id);
			yyerror(errormsg);
			goto bad;
		}
	}

	if (head) {
		newc->sid[0] = head->sid[0] + 1;
	} else {
		newc->sid[0] = 1;
	}
	newc->next = head;
	policydbp->ocontexts[OCON_ISID] = newc;

	return 0;

      bad:
	if (id)
		free(id);
	if (newc)
		free(newc);
	return -1;
}

static int define_common_perms(void)
{
	char *id = 0, *perm = 0;
	common_datum_t *comdatum = 0;
	perm_datum_t *perdatum = 0;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no common name for common perm definition?");
		return -1;
	}
	comdatum = (common_datum_t *) malloc(sizeof(common_datum_t));
	if (!comdatum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(comdatum, 0, sizeof(common_datum_t));
	comdatum->value = ++policydbp->p_commons.nprim;
	ret = hashtab_insert(policydbp->p_commons.table,
			 (hashtab_key_t) id, (hashtab_datum_t) comdatum);

	if (ret == HASHTAB_PRESENT) {
		yyerror("duplicate common definition");
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}
	if (symtab_init(&comdatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		goto bad;
	}
	while ((perm = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad_perm;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->value = ++comdatum->permissions.nprim;

#ifdef CONFIG_SECURITY_SELINUX_MLS
		/*
		 * By default, we set all four base permissions on this
		 * permission. This means that if base_permissions is not
		 * explicitly defined for this permission, then this
		 * permission will only be granted in the equivalent case.
		 */
		perdatum->base_perms = MLS_BASE_READ | MLS_BASE_WRITE |
		    MLS_BASE_READBY | MLS_BASE_WRITEBY;
#endif

		if (perdatum->value >= (sizeof(access_vector_t) * 8)) {
			yyerror("too many permissions to fit in an access vector");
			goto bad_perm;
		}
		ret = hashtab_insert(comdatum->permissions.table,
				     (hashtab_key_t) perm,
				     (hashtab_datum_t) perdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate permission %s in common %s",
				perm, id);
			yyerror(errormsg);
			goto bad_perm;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad_perm;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (comdatum)
		free(comdatum);
	return -1;

      bad_perm:
	if (perm)
		free(perm);
	if (perdatum)
		free(perdatum);
	return -1;
}


static int define_av_perms(int inherits)
{
	char *id;
	class_datum_t *cladatum;
	common_datum_t *comdatum;
	perm_datum_t *perdatum = 0, *perdatum2 = 0;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no tclass name for av perm definition?");
		return -1;
	}
	cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						    (hashtab_key_t) id);
	if (!cladatum) {
		sprintf(errormsg, "class %s is not defined", id);
		yyerror(errormsg);
		goto bad;
	}
	free(id);

	if (cladatum->comdatum || cladatum->permissions.nprim) {
		yyerror("duplicate access vector definition");
		return -1;
	}
	if (symtab_init(&cladatum->permissions, PERM_SYMTAB_SIZE)) {
		yyerror("out of memory");
		return -1;
	}
	if (inherits) {
		id = (char *) queue_remove(id_queue);
		if (!id) {
			yyerror("no inherits name for access vector definition?");
			return -1;
		}
		comdatum = (common_datum_t *) hashtab_search(policydbp->p_commons.table,
						     (hashtab_key_t) id);

		if (!comdatum) {
			sprintf(errormsg, "common %s is not defined", id);
			yyerror(errormsg);
			goto bad;
		}
		cladatum->comkey = id;
		cladatum->comdatum = comdatum;

		/*
		 * Class-specific permissions start with values 
		 * after the last common permission.
		 */
		cladatum->permissions.nprim += comdatum->permissions.nprim;
	}
	while ((id = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) malloc(sizeof(perm_datum_t));
		if (!perdatum) {
			yyerror("out of memory");
			goto bad;
		}
		memset(perdatum, 0, sizeof(perm_datum_t));
		perdatum->value = ++cladatum->permissions.nprim;

#ifdef CONFIG_SECURITY_SELINUX_MLS
		/*
		 * By default, we set all four base permissions on this
		 * permission. This means that if base_permissions is not
		 * explicitly defined for this permission, then this
		 * permission will only be granted in the equivalent case.
		 */
		perdatum->base_perms = MLS_BASE_READ | MLS_BASE_WRITE |
		    MLS_BASE_READBY | MLS_BASE_WRITEBY;
		/* actual value set in define_av_base */
#endif

		if (perdatum->value >= (sizeof(access_vector_t) * 8)) {
			yyerror("too many permissions to fit in an access vector");
			goto bad;
		}
		if (inherits) {
			/*
			 * Class-specific permissions and 
			 * common permissions exist in the same
			 * name space.
			 */
			perdatum2 = (perm_datum_t *) hashtab_search(cladatum->comdatum->permissions.table,
						     (hashtab_key_t) id);
			if (perdatum2) {
				sprintf(errormsg, "permission %s conflicts with an inherited permission", id);
				yyerror(errormsg);
				goto bad;
			}
		}
		ret = hashtab_insert(cladatum->permissions.table,
				     (hashtab_key_t) id,
				     (hashtab_datum_t) perdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate permission %s", id);
			yyerror(errormsg);
			goto bad;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (perdatum)
		free(perdatum);
	return -1;
}


static int define_sens(void)
{
#ifdef CONFIG_SECURITY_SELINUX_MLS
	char *id;
	mls_level_t *level = 0;
	level_datum_t *datum = 0, *aliasdatum = 0;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sensitivity name for sensitivity definition?");
		return -1;
	}
	level = (mls_level_t *) malloc(sizeof(mls_level_t));
	if (!level) {
		yyerror("out of memory");
		goto bad;
	}
	memset(level, 0, sizeof(mls_level_t));
	level->sens = 0;	/* actual value set in define_dominance */
	++policydbp->p_levels.nprim;
	ebitmap_init(&level->cat);	/* actual value set in define_level */

	datum = (level_datum_t *) malloc(sizeof(level_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(level_datum_t));
	datum->isalias = FALSE;
	datum->level = level;

	ret = hashtab_insert(policydbp->p_levels.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_levels.nprim;
		sprintf(errormsg, "duplicate definition for sensitivity %s", id);
		yyerror(errormsg);
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}

	while ((id = queue_remove(id_queue))) {
		aliasdatum = (level_datum_t *) malloc(sizeof(level_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		memset(aliasdatum, 0, sizeof(level_datum_t));
		aliasdatum->isalias = TRUE;
		aliasdatum->level = level;

		ret = hashtab_insert(policydbp->p_levels.table,
		       (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate definition for level %s", id);
			yyerror(errormsg);
			goto bad_alias;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad_alias;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (level)
		free(level);
	if (datum)
		free(datum);
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum)
		free(aliasdatum);
	return -1;
#else
	yyerror("sensitivity definition in non-MLS configuration");
	return -1;
#endif
}

static int define_dominance(void)
{
#ifdef CONFIG_SECURITY_SELINUX_MLS
	level_datum_t *datum;
	int order;
	char *id;

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	order = 0;
	while ((id = (char *) queue_remove(id_queue))) {
		datum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
		if (!datum) {
			sprintf(errormsg, "unknown sensitivity %s used in dominance definition", id);
			yyerror(errormsg);
			free(id);
			continue;
		}
		if (datum->level->sens != 0) {
			sprintf(errormsg, "sensitivity %s occurs multiply in dominance definition", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		datum->level->sens = ++order;

		/* no need to keep sensitivity name */
		free(id);
	}

	if (order != policydbp->p_levels.nprim) {
		yyerror("all sensitivities must be specified in dominance definition");
		return -1;
	}
	return 0;
#else
	yyerror("dominance definition in non-MLS configuration");
	return -1;
#endif
}

static int define_category(void)
{
#ifdef CONFIG_SECURITY_SELINUX_MLS
	char *id;
	cat_datum_t *datum = 0, *aliasdatum = 0;
	int ret;

	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no category name for category definition?");
		return -1;
	}
	datum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
	if (!datum) {
		yyerror("out of memory");
		goto bad;
	}
	memset(datum, 0, sizeof(cat_datum_t));
	datum->isalias = FALSE;
	datum->value = ++policydbp->p_cats.nprim;

	ret = hashtab_insert(policydbp->p_cats.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_cats.nprim;
		sprintf(errormsg, "duplicate definition for category %s", id);
		yyerror(errormsg);
		goto bad;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		goto bad;
	}

	while ((id = queue_remove(id_queue))) {
		aliasdatum = (cat_datum_t *) malloc(sizeof(cat_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			goto bad_alias;
		}
		memset(aliasdatum, 0, sizeof(cat_datum_t));
		aliasdatum->isalias = TRUE;
		aliasdatum->value = datum->value;

		ret = hashtab_insert(policydbp->p_cats.table,
		       (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "duplicate definition for category %s", id);
			yyerror(errormsg);
			goto bad_alias;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			goto bad_alias;
		}
	}

	return 0;

      bad:
	if (id)
		free(id);
	if (datum)
		free(datum);
	return -1;

      bad_alias:
	if (id)
		free(id);
	if (aliasdatum)
		free(aliasdatum);
	return -1;
#else
	yyerror("category definition in non-MLS configuration");
	return -1;
#endif
}


static int define_level(void)
{
#ifdef CONFIG_SECURITY_SELINUX_MLS
	int n;
	char *id, *levid;
	level_datum_t *levdatum;
	cat_datum_t *catdatum;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no level name for level definition?");
		return -1;
	}
	levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						    (hashtab_key_t) id);
	if (!levdatum) {
		sprintf(errormsg, "unknown sensitivity %s used in level definition", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (ebitmap_length(&levdatum->level->cat)) {
		sprintf(errormsg, "sensitivity %s used in multiple level definitions", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	levid = id;
	n = 1;
	while ((id = queue_remove(id_queue))) {
		catdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
						     (hashtab_key_t) id);
		if (!catdatum) {
			sprintf(errormsg, "unknown category %s used in level definition", id);
			yyerror(errormsg);
			free(id);
			continue;
		}
		if (ebitmap_set_bit(&levdatum->level->cat, catdatum->value - 1, TRUE)) {
			yyerror("out of memory");
			free(id);
			free(levid);
			return -1;
		}
		/* no need to keep category name */
		free(id);

		n = n * 2;
	}

	free(levid);

	policydbp->nlevels += n;

	return 0;
#else
	yyerror("level definition in non-MLS configuration");
	return -1;
#endif
}


static int define_common_base(void)
{
#ifdef CONFIG_SECURITY_SELINUX_MLS
	char *id, *perm, *base;
	common_datum_t *comdatum;
	perm_datum_t *perdatum;


	if (pass == 2) {
		id = queue_remove(id_queue); free(id);
		while ((id = queue_remove(id_queue))) {
			free(id);
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
		}
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no common name for common base definition?");
		return -1;
	}
	comdatum = (common_datum_t *) hashtab_search(policydbp->p_commons.table,
						     (hashtab_key_t) id);
	if (!comdatum) {
		sprintf(errormsg, "common %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	while ((perm = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) hashtab_search(comdatum->permissions.table,
						   (hashtab_key_t) perm);
		if (!perdatum) {
			sprintf(errormsg, "permission %s is not defined for common %s", perm, id);
			yyerror(errormsg);
			free(id);
			free(perm);
			return -1;
		}

		/*
		 * An explicit definition of base_permissions for this
		 * permission.  Reset the value to zero.
		 */
		perdatum->base_perms = 0;

		while ((base = queue_remove(id_queue))) {
			if (!strcmp(base, "read"))
				perdatum->base_perms |= MLS_BASE_READ;
			else if (!strcmp(base, "write"))
				perdatum->base_perms |= MLS_BASE_WRITE;
			else if (!strcmp(base, "readby"))
				perdatum->base_perms |= MLS_BASE_READBY;
			else if (!strcmp(base, "writeby"))
				perdatum->base_perms |= MLS_BASE_WRITEBY;
			else if (strcmp(base, "none")) {
				sprintf(errormsg, "base permission %s is not defined", base);
				yyerror(errormsg);
				free(base);
				return -1;
			}
			free(base);
		}

		free(perm);
	}

	free(id);

	return 0;
#else
	yyerror("MLS base permission definition in non-MLS configuration");
	return -1;
#endif
}


#ifdef CONFIG_SECURITY_SELINUX_MLS
static int common_base_set(hashtab_key_t key, hashtab_datum_t datum, void *p)
{
	perm_datum_t *perdatum;
	class_datum_t *cladatum;

	perdatum = (perm_datum_t *) datum;
	cladatum = (class_datum_t *) p;

	if (perdatum->base_perms & MLS_BASE_READ)
		cladatum->mlsperms.read |= (1 << (perdatum->value - 1));

	if (perdatum->base_perms & MLS_BASE_WRITE)
		cladatum->mlsperms.write |= (1 << (perdatum->value - 1));

	if (perdatum->base_perms & MLS_BASE_READBY)
		cladatum->mlsperms.readby |= (1 << (perdatum->value - 1));

	if (perdatum->base_perms & MLS_BASE_WRITEBY)
		cladatum->mlsperms.writeby |= (1 << (perdatum->value - 1));

	return 0;
}
#endif

static int define_av_base(void)
{
#ifdef CONFIG_SECURITY_SELINUX_MLS
	char *id, *base;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;

	if (pass == 2) {
		id = queue_remove(id_queue); free(id);
		while ((id = queue_remove(id_queue))) {
			free(id);
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
		}
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no tclass name for av base definition?");
		return -1;
	}
	cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						    (hashtab_key_t) id);
	if (!cladatum) {
		sprintf(errormsg, "class %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	free(id);

	/*
	 * Determine which common permissions should be included in each MLS
	 * vector for this access vector definition.
	 */
	if (cladatum->comdatum)
		hashtab_map(cladatum->comdatum->permissions.table, common_base_set, cladatum);

	while ((id = queue_remove(id_queue))) {
		perdatum = (perm_datum_t *) hashtab_search(cladatum->permissions.table,
						     (hashtab_key_t) id);
		if (!perdatum) {
			sprintf(errormsg, "permission %s is not defined", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		/*
		 * An explicit definition of base_permissions for this
		 * permission.  Reset the value to zero.
		 */
		perdatum->base_perms = 0;

		while ((base = queue_remove(id_queue))) {
			if (!strcmp(base, "read")) {
				perdatum->base_perms |= MLS_BASE_READ;
			} else if (!strcmp(base, "write")) {
				perdatum->base_perms |= MLS_BASE_WRITE;
			} else if (!strcmp(base, "readby")) {
				perdatum->base_perms |= MLS_BASE_READBY;
			} else if (!strcmp(base, "writeby")) {
				perdatum->base_perms |= MLS_BASE_WRITEBY;
			} else if (strcmp(base, "none")) {
				sprintf(errormsg, "base permission %s is not defined", base);
				yyerror(errormsg);
				free(base);
				continue;
			}
			free(base);
		}

		free(id);
	}

	/* Set MLS base permission masks */
	hashtab_map(cladatum->permissions.table, common_base_set, cladatum);

	return 0;
#else
	yyerror("MLS base permission definition in non-MLS configuration");
	return -1;
#endif
}

static int define_attrib(void)
{
	char *id;
	type_datum_t *attr;
	int ret;


	if (pass == 2) {
		free(queue_remove(id_queue));
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		return -1;
	}

	attr = hashtab_search(policydbp->p_types.table, id);
	if (attr) {
		sprintf(errormsg, "duplicate declaration for attribute %s\n",
			id);
		yyerror(errormsg);
		return -1;
	}

	attr = (type_datum_t *) malloc(sizeof(type_datum_t));
	if (!attr) {
		yyerror("out of memory");
		return -1;
	}
	memset(attr, 0, sizeof(type_datum_t));
	attr->isattr = TRUE;
	ret = hashtab_insert(policydbp->p_types.table,
			     id, (hashtab_datum_t) attr);
	if (ret) {
		yyerror("hash table overflow");
		return -1;
	}

	return 0;
}

static int define_typealias(void)
{
	char *id;
	type_datum_t *t, *aliasdatum;;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for typealias definition?");
		return -1;
	}

	t = hashtab_search(policydbp->p_types.table, id);
	if (!t || t->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	while ((id = queue_remove(id_queue))) {
		aliasdatum = (type_datum_t *) malloc(sizeof(type_datum_t));
		if (!aliasdatum) {
			yyerror("out of memory");
			return -1;
		}
		memset(aliasdatum, 0, sizeof(type_datum_t));
		aliasdatum->value = t->value;

		ret = hashtab_insert(policydbp->p_types.table,
				     (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

		if (ret == HASHTAB_PRESENT) {
			sprintf(errormsg, "name conflict for type alias %s", id);
			yyerror(errormsg);
			free(aliasdatum);
			free(id);
			return -1;
		}
		if (ret == HASHTAB_OVERFLOW) {
			yyerror("hash table overflow");
			free(aliasdatum);
			free(id);
			return -1;
		}
	}
	return 0;
}

static int define_type(int alias)
{
	char *id;
	type_datum_t *datum, *aliasdatum, *attr;
	int ret, newattr = 0;


	if (pass == 2) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		if (alias) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for type definition?");
		return -1;
	}

	datum = (type_datum_t *) malloc(sizeof(type_datum_t));
	if (!datum) {
		yyerror("out of memory");
		free(id);
		return -1;
	}
	memset(datum, 0, sizeof(type_datum_t));
	datum->primary = TRUE;
	datum->value = ++policydbp->p_types.nprim;

	ret = hashtab_insert(policydbp->p_types.table,
			     (hashtab_key_t) id, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_types.nprim;
		free(datum);
		sprintf(errormsg, "name conflict for type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		free(datum);
		free(id);
		return -1;
	}

	if (alias) { 
		while ((id = queue_remove(id_queue))) {
			aliasdatum = (type_datum_t *) malloc(sizeof(type_datum_t));
			if (!aliasdatum) {
				yyerror("out of memory");
				return -1;
			}
			memset(aliasdatum, 0, sizeof(type_datum_t));
			aliasdatum->value = datum->value;

			ret = hashtab_insert(policydbp->p_types.table,
					     (hashtab_key_t) id, (hashtab_datum_t) aliasdatum);

			if (ret == HASHTAB_PRESENT) {
				sprintf(errormsg, "name conflict for type alias %s", id);
				yyerror(errormsg);
				free(aliasdatum);
				free(id);
				return -1;
			}
			if (ret == HASHTAB_OVERFLOW) {
				yyerror("hash table overflow");
				free(aliasdatum);
				free(id);
				return -1;
			}
		}
	}

	while ((id = queue_remove(id_queue))) {
#ifdef CONFIG_SECURITY_SELINUX_MLS
		if (!strcmp(id, "mlstrustedreader")) {
			if (ebitmap_set_bit(&policydbp->trustedreaders, datum->value - 1, TRUE)) {
				yyerror("out of memory");
				free(id);
				return -1;
			}
		} else if (!strcmp(id, "mlstrustedwriter")) {
			if (ebitmap_set_bit(&policydbp->trustedwriters, datum->value - 1, TRUE)) {
				yyerror("out of memory");
				free(id);
				return -1;
			}
		} else if (!strcmp(id, "mlstrustedobject")) {
			if (ebitmap_set_bit(&policydbp->trustedobjects, datum->value - 1, TRUE)) {
				yyerror("out of memory");
				free(id);
				return -1;
			}
		}
#endif
		attr = hashtab_search(policydbp->p_types.table, id);
		if (!attr) {
			sprintf(errormsg, "attribute %s is not declared", id);
#if 1
			/* treat it as a fatal error */
			yyerror(errormsg);
			return -1;
#else
			/* Warn but automatically define the attribute.
			   Useful for quickly finding all those attributes you
			   forgot to declare. */
			yywarn(errormsg);
			attr = (type_datum_t *) malloc(sizeof(type_datum_t));
			if (!attr) {
				yyerror("out of memory");
				return -1;
			}
			memset(attr, 0, sizeof(type_datum_t));
			attr->isattr = TRUE;
			ret = hashtab_insert(policydbp->p_types.table,
					     id, (hashtab_datum_t) attr);
			if (ret) {
				yyerror("hash table overflow");
				return -1;
			}
			newattr = 1;
#endif
		} else {
			newattr = 0;
		}

		if (!attr->isattr) {
			sprintf(errormsg, "%s is a type, not an attribute", id);
			yyerror(errormsg);
			return -1;
		}

		if (!newattr)
			free(id);

		ebitmap_set_bit(&attr->types, datum->value - 1, TRUE);
	}

	return 0;
}

struct val_to_name {
	unsigned int val;
	char *name;
};

static int type_val_to_name_helper(hashtab_key_t key, hashtab_datum_t datum, void *p)
{
	type_datum_t *typdatum;
	struct val_to_name *v = p;

	typdatum = (type_datum_t *) datum;

	if (v->val == typdatum->value) {
		v->name = key;
		return 1;
	}

	return 0;
}

static char *type_val_to_name(unsigned int val) 
{
	struct val_to_name v;
	int rc;

	v.val = val;
	rc = hashtab_map(policydbp->p_types.table, 
			 type_val_to_name_helper, &v);
	if (rc)
		return v.name;
	return NULL;
}


static int set_types(ebitmap_t *set,
		     ebitmap_t *negset,
		     char *id,
		     int *add)
{
	type_datum_t *t;
	unsigned int i;

	if (strcmp(id, "*") == 0) {
		/* set all types not in negset */
		for (i = 0; i < policydbp->p_types.nprim; i++) {
			if (!ebitmap_get_bit(negset, i))
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		/* complement the set */
		for (i = 0; i < policydbp->p_types.nprim; i++) {
			if (ebitmap_get_bit(set, i))
				ebitmap_set_bit(set, i, FALSE);
			else 
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	if (strcmp(id, "-") == 0) {
		*add = 0;
		free(id);
		return 0;
	}	

	t = hashtab_search(policydbp->p_types.table, id);
	if (!t) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	if (t->isattr) {
		/* set or clear all types with this attribute,
		   but do not set anything explicitly cleared previously */
		for (i = ebitmap_startbit(&t->types); i < ebitmap_length(&t->types); i++) {
			if (!ebitmap_get_bit(&t->types, i)) 
				continue;		
			if (!(*add)) {
				ebitmap_set_bit(set, i, FALSE);
				ebitmap_set_bit(negset, i, TRUE);
			} else if (!ebitmap_get_bit(negset, i)) {
				ebitmap_set_bit(set, i, TRUE);
#if VERBOSE
			} else {
				char *name = type_val_to_name(i+1);
				sprintf(errormsg, "ignoring %s due to prior -%s", name, name);
				yywarn(errormsg);
#endif
			}
		}
	} else {
		/* set or clear one type, but do not set anything
		   explicitly cleared previously */	
		if (!(*add)) {
			ebitmap_set_bit(set, t->value - 1, FALSE);
			ebitmap_set_bit(negset, t->value - 1, TRUE);
		} else if (!ebitmap_get_bit(negset, t->value - 1)) {
			ebitmap_set_bit(set, t->value - 1, TRUE);
#if VERBOSE
		} else {
			sprintf(errormsg, "ignoring %s due to prior -%s", id, id);
			yywarn(errormsg);
#endif
		}
	}

	free(id);
	*add = 1;
	return 0;
}


static int define_compute_type(int which)
{
	char *id;
	avtab_key_t avkey;
	avtab_datum_t avdatum, *avdatump;
	type_datum_t *datum;
	class_datum_t *cladatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	uint32_t newtype = 0;
	int ret, add = 1;
	unsigned int i, j, k;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&ttypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	while ((id = queue_remove(id_queue))) {
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s", id);
			yyerror(errormsg);
			goto bad;
		}
		ebitmap_set_bit(&tclasses, cladatum->value - 1, TRUE);
		free(id);
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no newtype?");
		goto bad;
	}
	datum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						(hashtab_key_t) id);
	if (!datum || datum->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		goto bad;
	}

	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			for (k = ebitmap_startbit(&tclasses); k < ebitmap_length(&tclasses); k++) {
				if (!ebitmap_get_bit(&tclasses, k)) 
					continue;
				avkey.source_type = i + 1;
				avkey.target_type = j + 1;
				avkey.target_class = k + 1;
				avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_TYPE);
				if (avdatump) {
					switch (which) {
					case AVTAB_TRANSITION:
						newtype = avtab_transition(avdatump);
						break;
					case AVTAB_MEMBER:
						newtype = avtab_member(avdatump);
						break;
					case AVTAB_CHANGE:
						newtype = avtab_change(avdatump);
						break;
					}
					if ( (avdatump->specified & which) &&
					     (newtype != datum->value) ) {
						sprintf(errormsg, "conflicting rule for (%s, %s:%s):  default was %s, is now %s", type_val_to_name(i+1), type_val_to_name(j+1), policydbp->p_class_val_to_name[k],
							type_val_to_name(newtype),
							type_val_to_name(datum->value));
						yywarn(errormsg);
					}
					avdatump->specified |= which;
					switch (which) {
					case AVTAB_TRANSITION:
						avtab_transition(avdatump) = datum->value;
						break;
					case AVTAB_MEMBER:
						avtab_member(avdatump) = datum->value;
						break;
					case AVTAB_CHANGE:
						avtab_change(avdatump) = datum->value;
						break;
					}
				} else {
					memset(&avdatum, 0, sizeof avdatum);
					avdatum.specified |= which;
					switch (which) {
					case AVTAB_TRANSITION:
					        avtab_transition(&avdatum) = datum->value;
						break;
					case AVTAB_MEMBER:
						avtab_member(&avdatum) = datum->value;
						break;
					case AVTAB_CHANGE:
						avtab_change(&avdatum) = datum->value;
						break;
					}
					ret = avtab_insert(&policydbp->te_avtab, &avkey, &avdatum);
					if (ret) {
						yyerror("hash table overflow");
						goto bad;
					}
				}
			}
		}
	}

	return 0;

      bad:
	return -1;
}

static cond_av_list_t *define_cond_compute_type(int which)
{
	char *id;
	cond_av_list_t *sub_list;
	avtab_key_t avkey;
	avtab_datum_t avdatum, *avdatump;
	type_datum_t *datum;
	class_datum_t *cladatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	uint32_t newtype = 0;
	int i, j, k, add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		while ((id = queue_remove(id_queue)))
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return (cond_av_list_t *)1; /* any non-NULL value */
	}
	
	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return  COND_ERR;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&ttypes, &negset, id, &add))
			return COND_ERR;
	}
	ebitmap_destroy(&negset);

	while ((id = queue_remove(id_queue))) {
		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s", id);
			yyerror(errormsg);
			goto bad;
		}
		ebitmap_set_bit(&tclasses, cladatum->value - 1, TRUE);
		free(id);
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no newtype?");
		goto bad;
	}
	datum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						(hashtab_key_t) id);
	if (!datum || datum->isattr) {
		sprintf(errormsg, "unknown type %s", id);
		yyerror(errormsg);
		goto bad;
	}

	/* create sub_list to be passed back and appended to true or false list */
	sub_list = (cond_av_list_t *) 0;

	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			for (k = ebitmap_startbit(&tclasses); k < ebitmap_length(&tclasses); k++) {
				if (!ebitmap_get_bit(&tclasses, k)) 
					continue;
				avkey.source_type = i + 1;
				avkey.target_type = j + 1;
				avkey.target_class = k + 1;
				avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_TYPE);
				
				/* does rule exist in base policy? */
				if ((avdatump) && (avdatump->specified & which)) {
					switch (which) {
					case AVTAB_TRANSITION:
						newtype = avtab_transition(avdatump);
						break;
					case AVTAB_MEMBER:
						newtype = avtab_member(avdatump);
						break;
					case AVTAB_CHANGE:
						newtype = avtab_change(avdatump);
						break;
					}
					if ( (newtype != datum->value) ) {
						sprintf(errormsg, "conflicting type rule for conditional "
							"(%s, %s:%s) in base: default is %s, conditional %s "
							"will be ignored", 
							type_val_to_name(i+1), 
							type_val_to_name(j+1), 
							policydbp->p_class_val_to_name[k],
							type_val_to_name(newtype),
							type_val_to_name(datum->value));
						yywarn(errormsg);
					} else {
						sprintf(errormsg, "conditional type rule (%s, %s:%s): "
							"has same default, %s, as rule in base policy; "
							"conditional %s will be ignored", 
							type_val_to_name(i+1), 
							type_val_to_name(j+1), 
							policydbp->p_class_val_to_name[k],
							type_val_to_name(newtype),
							type_val_to_name(datum->value));
						yywarn(errormsg);
					}
				}
				/* rule does not exist in base policy */
				else {
					
					memset(&avdatum, 0, sizeof avdatum);
					avdatum.specified |= which;
					switch (which) {
					case AVTAB_TRANSITION:
					        avtab_transition(&avdatum) = datum->value;
						break;
					case AVTAB_MEMBER:
						avtab_member(&avdatum) = datum->value;
						break;
					case AVTAB_CHANGE:
						avtab_change(&avdatum) = datum->value;
						break;
					}
					/* add rule to sub list */
					sub_list = cond_list_append(sub_list, &avkey, &avdatum);
					if (sub_list == COND_ERR) {
						yyerror("list overflow");
						goto bad;
					}
				}
			}
		}
	}
	
	return sub_list;

      bad:
	return COND_ERR;
}

static cond_av_list_t *cond_list_append(cond_av_list_t *sl, avtab_key_t *key, avtab_datum_t *datum) {

	cond_av_list_t  *n, *end;

	n = (cond_av_list_t *) malloc(sizeof(cond_av_list_t));
	if (!n) {
		  yyerror("out of memory");
		  return COND_ERR;
	}
	memset(n, 0, sizeof(cond_av_list_t));
	if (sl) {
		for(end=sl; end->next != NULL; end = end->next);
		end->next = n;
	}
	else sl = n;
	n->next = NULL;
	
	/* construct new node */
	n->node = (avtab_ptr_t) malloc(sizeof(struct avtab_node));
	if (!n->node) {
		yyerror("out of memory");
		return COND_ERR;
	}
	memset(n->node, 0, sizeof(struct avtab_node));
	n->node->key = *key;
	n->node->datum = *datum;
	/* the next two fields get filled in when we add to true/false list  */
	n->node->next = (avtab_ptr_t) 0;
	n->node->parse_context = (void *) 0;
	
	return(sl);
}


static int perm_name(hashtab_key_t key, hashtab_datum_t datum, void *data)
{
	struct val_to_name *v = data;
	perm_datum_t *perdatum;

	perdatum = (perm_datum_t *) datum;

	if (v->val == perdatum->value) {
		v->name = key;
		return 1;
	}

	return 0;
}


char *av_to_string(uint32_t tclass, access_vector_t av)
{
	struct val_to_name v;
	static char avbuf[1024];
	class_datum_t *cladatum;
	char *perm = NULL, *p;
	unsigned int i;
	int rc;

	cladatum = policydbp->class_val_to_struct[tclass-1];
	p = avbuf;
	for (i = 0; i < cladatum->permissions.nprim; i++) {
		if (av & (1 << i)) {
			v.val = i+1;
			rc = hashtab_map(cladatum->permissions.table,
					 perm_name, &v);
			if (!rc && cladatum->comdatum) {
				rc = hashtab_map(
					cladatum->comdatum->permissions.table,
					perm_name, &v);
			}
			if (rc)
				perm = v.name;
			if (perm) {
				sprintf(p, " %s", perm);
				p += strlen(p);
			}
		}
	}

	return avbuf;
}

static int define_bool()
{
	char *id, *name;
	cond_bool_datum_t *datum;
	int ret;


	if (pass == 2) {
		while ((id = queue_remove(id_queue)))
			free(id);
		return 0;
	}		

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no identifier for bool definition?");
		return -1;
	}
	name = id;

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no default value for bool definition?");
		free(name);
		return -1;
	}

	datum = (cond_bool_datum_t *) malloc(sizeof(cond_bool_datum_t));
	if (!datum) {
		yyerror("out of memory");
		free(id);
		free(name);
		return -1;
	}
	memset(datum, 0, sizeof(cond_bool_datum_t));
	datum->state = (int)(id[0] == 'T') ? 1 : 0;
	datum->value = ++policydbp->p_bools.nprim;

	ret = hashtab_insert(policydbp->p_bools.table,
			     (hashtab_key_t) name, (hashtab_datum_t) datum);

	if (ret == HASHTAB_PRESENT) {
		--policydbp->p_bools.nprim;
		free(datum);
		sprintf(errormsg, "name conflict for bool %s", id);
		yyerror(errormsg);
		free(id);
		free(name);
		return -1;
	}
	if (ret == HASHTAB_OVERFLOW) {
		yyerror("hash table overflow");
		free(datum);
		free(id);
		free(name);
		return -1;
	}
	return 0;
}

static cond_av_list_t *define_cond_pol_list( cond_av_list_t *avlist, cond_av_list_t *sl )
{
	cond_av_list_t *end;

	if (pass == 1) {
		/* return something so we get through pass 1 */
		return (cond_av_list_t *)1;
	}

	/* if we've started collecting sub lists, prepend to start of collection
	   because it's probably less iterations than appending. */
	if (!sl) return avlist;
	else if (!avlist) return sl;
	else {
		end = sl;
		while (end->next) end = end->next;
		end->next = avlist;
	} 
	return sl;
}

static int te_avtab_helper(int which, unsigned int stype, unsigned int ttype, 
			   ebitmap_t *tclasses, access_vector_t *avp)

{
	avtab_key_t avkey;
	avtab_datum_t avdatum, *avdatump;
	int ret;
	unsigned int k;

	if (which == -AVTAB_ALLOWED) {
		yyerror("neverallow should not reach this function.");
		return -1;
	}

	for (k = ebitmap_startbit(tclasses); k < ebitmap_length(tclasses); k++) {
		if (!ebitmap_get_bit(tclasses, k)) 
			continue;
		avkey.source_type = stype + 1;
		avkey.target_type = ttype + 1;
		avkey.target_class = k + 1;
		avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_AV);
		if (!avdatump) {
			memset(&avdatum, 0, sizeof avdatum);
			avdatum.specified = (which > 0) ? which : -which;
			ret = avtab_insert(&policydbp->te_avtab, &avkey, &avdatum);
			if (ret) {
				yyerror("hash table overflow");
				return -1;
			}
			avdatump = avtab_search(&policydbp->te_avtab, &avkey, AVTAB_AV);
			if (!avdatump) {
				yyerror("inserted entry vanished!");
				return -1;
			}
		}

		avdatump->specified |= ((which > 0) ? which : -which);

		switch (which) {
		case AVTAB_ALLOWED:
			avtab_allowed(avdatump) |= avp[k];
			break;
		case AVTAB_AUDITALLOW:
			avtab_auditallow(avdatump) |= avp[k];
			break;
		case AVTAB_AUDITDENY:
			avtab_auditdeny(avdatump) |= avp[k];
			break;
		case -AVTAB_AUDITDENY:
			if (avtab_auditdeny(avdatump))
				avtab_auditdeny(avdatump) &= ~avp[k];
			else
				avtab_auditdeny(avdatump) = ~avp[k];
			break;
		}
	}

	return 0;
}

static  cond_av_list_t *cond_te_avtab_helper(int which, int stype, int ttype, 
			   ebitmap_t *tclasses, access_vector_t *avp )

{
	cond_av_list_t *sl;
	avtab_key_t avkey;
	avtab_datum_t avdatum;
	int  k;

	if (which == -AVTAB_ALLOWED) {
		yyerror("neverallow should not reach this function.");
		return COND_ERR;
	}

	/* create sub_list to be passed back and appended to true or false list */
	sl = (cond_av_list_t *) 0;

	for (k = ebitmap_startbit(tclasses); k < ebitmap_length(tclasses); k++) {
		if (!ebitmap_get_bit(tclasses, k)) 
			continue;
		/* build the key */
		avkey.source_type = stype + 1;
		avkey.target_type = ttype + 1;
		avkey.target_class = k + 1;
		
		/* build the datum */
		memset(&avdatum, 0, sizeof avdatum);
		avdatum.specified = (which > 0) ? which : -which;

		switch (which) {
		case AVTAB_ALLOWED:
			avtab_allowed(&avdatum) = avp[k];
			break;
		case AVTAB_AUDITALLOW:
			avtab_auditallow(&avdatum) = avp[k];
			break;
		case AVTAB_AUDITDENY:
			yyerror("AUDITDENY statements are not allowed in a conditional block; use DONTAUDIT");
			return COND_ERR;
		case -AVTAB_AUDITDENY:
			avtab_auditdeny(&avdatum) = ~avp[k];
			break;
		}

		/* add to temporary list */
		sl = cond_list_append(sl, &avkey, &avdatum);

		if (sl == COND_ERR) {
			yyerror("list overflow");
			return COND_ERR;
		}
	}

	return sl;
}

static cond_av_list_t *define_cond_te_avtab(int which)
{
	char *id;
	cond_av_list_t *sub_list, *final_list, *tail;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	access_vector_t *avp;
	int i, j, hiclass, self = 0, add = 1;
	int suppress = 0;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return (cond_av_list_t *) 1; /* any non-NULL value */
	}

	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return COND_ERR;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (strcmp(id, "self") == 0) {
			self = 1;
			continue;
		}
		if (set_types(&ttypes, &negset, id, &add))
			return COND_ERR;
	}
	ebitmap_destroy(&negset);

	hiclass = 0;
	while ((id = queue_remove(id_queue))) {
		uint32_t classvalue;

		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) 	{
			sprintf(errormsg, "unknown class %s used in rule", id);
			yyerror(errormsg);
			goto bad;
		}
		
		if (policyvers < POLICYDB_VERSION_NLCLASS &&
		    (cladatum->value >= SECCLASS_NETLINK_ROUTE_SOCKET &&
		     cladatum->value <= SECCLASS_NETLINK_DNRT_SOCKET)) {
			sprintf(errormsg, "remapping class %s to netlink_socket "
			        "for policy version %d", id, policyvers);
			yywarn(errormsg);
			classvalue = SECCLASS_NETLINK_SOCKET;
			suppress = 1;
		} else 
			classvalue = cladatum->value;
		
		ebitmap_set_bit(&tclasses, classvalue - 1, TRUE);	
		if (classvalue > hiclass)
			hiclass = classvalue;
		free(id);
	}

	avp = malloc(hiclass * sizeof(access_vector_t));
	if (!avp) {
		yyerror("out of memory");
		return COND_ERR;
	}
	for (i = 0; i < hiclass; i++)
		avp[i] = 0;
	while ((id = queue_remove(id_queue))) {
		for (i = ebitmap_startbit(&tclasses); i < ebitmap_length(&tclasses); i++) {
			if (!ebitmap_get_bit(&tclasses, i)) 
				continue;
			cladatum = policydbp->class_val_to_struct[i];

			if (strcmp(id, "*") == 0) {
				/* set all permissions in the class */
				avp[i] = ~0;
				continue;
			}

			if (strcmp(id, "~") == 0) {
				/* complement the set */
				if (which == -AVTAB_AUDITDENY) 
					yywarn("dontaudit rule with a ~?");
				avp[i] = ~avp[i];
				continue;
			}

			perdatum = hashtab_search(cladatum->permissions.table,
						  id);
			if (!perdatum) {
				if (cladatum->comdatum) {
					perdatum = hashtab_search(cladatum->comdatum->permissions.table,
								  id);
				}
			}
			if (!perdatum) {
				sprintf(errormsg, "permission %s is not defined for class %s", id, policydbp->p_class_val_to_name[i]);
				if (!suppress)
				  yyerror(errormsg);
				continue;
			}

			avp[i] |= (1 << (perdatum->value - 1));
		}

		free(id);
	}

	sub_list = NULL;
	tail = NULL;
	final_list = NULL;

	if (self) {
		for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
			if (!ebitmap_get_bit(&stypes, i)) 
				continue;
			if (self) {
				if ((sub_list = cond_te_avtab_helper(which, i, i, &tclasses, avp )) == COND_ERR)
					return COND_ERR;
				if (final_list) {
					tail->next = sub_list;
					while (tail->next != NULL)
						tail = tail->next;
				} else {
					final_list = sub_list;
					tail = final_list;
					while (tail->next != NULL)
						tail = tail->next;
				}
			}
		}
	}
	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			if ((sub_list = cond_te_avtab_helper(which, i, j, &tclasses, avp)) == COND_ERR)
				return COND_ERR;
			if (final_list) {
				tail->next = sub_list;
				while (tail->next != NULL)
					tail = tail->next;
			} else {
				final_list = sub_list;
				tail = final_list;
				while (tail->next != NULL)
					tail = tail->next;
			}
		}
	}

	ebitmap_destroy(&stypes);
	ebitmap_destroy(&ttypes);
	ebitmap_destroy(&tclasses);
	free(avp);
	
	return final_list;
 bad:
	return COND_ERR;
}


static int define_te_avtab(int which)
{
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t stypes, ttypes, tclasses, negset;
	access_vector_t *avp;
	unsigned int i, j, hiclass;
	int self = 0, add = 1;
	te_assert_t *newassert;
	int suppress = 0;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	ebitmap_init(&stypes);
	ebitmap_init(&ttypes);
	ebitmap_init(&tclasses);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&stypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (strcmp(id, "self") == 0) {
			self = 1;
			continue;
		}
		if (set_types(&ttypes, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	hiclass = 0;
	while ((id = queue_remove(id_queue))) {
		uint32_t classvalue;

		cladatum = hashtab_search(policydbp->p_classes.table, id);
		if (!cladatum) {
			sprintf(errormsg, "unknown class %s used in rule", id);
			yyerror(errormsg);
			goto bad;
		}
		
		if (policyvers < POLICYDB_VERSION_NLCLASS &&
		    (cladatum->value >= SECCLASS_NETLINK_ROUTE_SOCKET &&
		     cladatum->value <= SECCLASS_NETLINK_DNRT_SOCKET)) {
			sprintf(errormsg, "remapping class %s to netlink_socket "
			        "for policy version %d", id, policyvers);
			yywarn(errormsg);
			classvalue = SECCLASS_NETLINK_SOCKET;
			suppress = 1;
		} else
			classvalue = cladatum->value;
				
		ebitmap_set_bit(&tclasses, classvalue - 1, TRUE);	
		if (classvalue > hiclass)
			hiclass = classvalue;
		free(id);
	}

	avp = malloc(hiclass * sizeof(access_vector_t));
	if (!avp) {
		yyerror("out of memory");
		return -1;
	}
	for (i = 0; i < hiclass; i++)
		avp[i] = 0;

	while ((id = queue_remove(id_queue))) {
		for (i = ebitmap_startbit(&tclasses); i < ebitmap_length(&tclasses); i++) {
			if (!ebitmap_get_bit(&tclasses, i)) 
				continue;
			cladatum = policydbp->class_val_to_struct[i];

			if (strcmp(id, "*") == 0) {
				/* set all permissions in the class */
				avp[i] = ~0U;
				continue;
			}

			if (strcmp(id, "~") == 0) {
				/* complement the set */
				if (which == -AVTAB_AUDITDENY) 
					yywarn("dontaudit rule with a ~?");
				avp[i] = ~avp[i];
				continue;
			}

			perdatum = hashtab_search(cladatum->permissions.table,
						  id);
			if (!perdatum) {
				if (cladatum->comdatum) {
					perdatum = hashtab_search(cladatum->comdatum->permissions.table,
								  id);
				}
			}
			if (!perdatum) {
				sprintf(errormsg, "permission %s is not defined for class %s", id, policydbp->p_class_val_to_name[i]);
				if (!suppress)
				  yyerror(errormsg);
				continue;
			}

			avp[i] |= (1 << (perdatum->value - 1));
		}

		free(id);
	}

	if (which == -AVTAB_ALLOWED) {
		newassert = malloc(sizeof(te_assert_t));
		if (!newassert) {
			yyerror("out of memory");
			return -1;
		}
		memset(newassert, 0, sizeof(te_assert_t));
		newassert->stypes = stypes;
		newassert->ttypes = ttypes;
		newassert->tclasses = tclasses;
		newassert->self = self;
		newassert->avp = avp;
		newassert->line = policydb_lineno;
		newassert->next = te_assertions;
		te_assertions = newassert;
		return 0;
	}

	for (i = ebitmap_startbit(&stypes); i < ebitmap_length(&stypes); i++) {
		if (!ebitmap_get_bit(&stypes, i)) 
			continue;
		if (self) {
			if (te_avtab_helper(which, i, i, &tclasses, avp))
				return -1;
		}
		for (j = ebitmap_startbit(&ttypes); j < ebitmap_length(&ttypes); j++) {
			if (!ebitmap_get_bit(&ttypes, j)) 
				continue;
			if (te_avtab_helper(which, i, j, &tclasses, avp))
				return -1;
		}
	}

	ebitmap_destroy(&stypes);
	ebitmap_destroy(&ttypes);
	ebitmap_destroy(&tclasses);
	free(avp);

	return 0;
 bad:
	return -1;
}


static int role_val_to_name_helper(hashtab_key_t key, hashtab_datum_t datum, void *p)
{
	struct val_to_name *v = p;
	role_datum_t *roldatum;

	roldatum = (role_datum_t *) datum;

	if (v->val == roldatum->value) {
		v->name = key;
		return 1;
	}

	return 0;
}


static char *role_val_to_name(unsigned int val) 
{
	struct val_to_name v;
	int rc;

	v.val = val;
	rc = hashtab_map(policydbp->p_roles.table, 
			 role_val_to_name_helper, &v);
	if (rc)
		return v.name;
	return NULL;
}

static int define_role_types(void)
{
	role_datum_t *role;
	char *role_id, *id;
	int ret, add = 1;
	ebitmap_t negset;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	role_id = queue_remove(id_queue);

	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       role_id);
	if (!role) {
		role = (role_datum_t *) malloc(sizeof(role_datum_t));
		if (!role) {
			yyerror("out of memory");
			free(role_id);
			return -1;
		}
		memset(role, 0, sizeof(role_datum_t));
		role->value = ++policydbp->p_roles.nprim;
		ebitmap_set_bit(&role->dominates, role->value-1, TRUE);
		ret = hashtab_insert(policydbp->p_roles.table,
				     (hashtab_key_t) role_id, (hashtab_datum_t) role);

		if (ret) {
			yyerror("hash table overflow");
			free(role);
			free(role_id);
			return -1;
		}
	} else
		free(role_id);

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&role->types, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	return 0;
}


static role_datum_t *
 merge_roles_dom(role_datum_t * r1, role_datum_t * r2)
{
	role_datum_t *new;

	if (pass == 1) {
		return (role_datum_t *)1; /* any non-NULL value */
	}

	new = malloc(sizeof(role_datum_t));
	if (!new) {
		yyerror("out of memory");
		return NULL;
	}
	memset(new, 0, sizeof(role_datum_t));
	new->value = 0;		/* temporary role */
	if (ebitmap_or(&new->dominates, &r1->dominates, &r2->dominates)) {
		yyerror("out of memory");
		return NULL;
	}
	if (ebitmap_or(&new->types, &r1->types, &r2->types)) {
		yyerror("out of memory");
		return NULL;
	}
	if (!r1->value) {
		/* free intermediate result */
		ebitmap_destroy(&r1->types);
		ebitmap_destroy(&r1->dominates);
		free(r1);
	}
	if (!r2->value) {
		/* free intermediate result */
		yyerror("right hand role is temporary?");
		ebitmap_destroy(&r2->types);
		ebitmap_destroy(&r2->dominates);
		free(r2);
	}
	return new;
}

/* This function eliminates the ordering dependency of role dominance rule */
static int dominate_role_recheck(hashtab_key_t key, hashtab_datum_t datum, void *arg)
{
	role_datum_t *rdp = (role_datum_t *) arg;
	role_datum_t *rdatum = (role_datum_t *) datum;
	int i;

	/* Don't bother to process against self role */
	if (rdatum->value == rdp->value)
		return 0;

	/* If a dominating role found */
	if (ebitmap_get_bit(&(rdatum->dominates), rdp->value - 1))
	{
		/* raise types and dominates from dominated role */
		for (i = ebitmap_startbit(&rdp->dominates); 
			i < ebitmap_length(&rdp->dominates); i++) 
		{
			if (ebitmap_get_bit(&rdp->dominates, i))
				ebitmap_set_bit(&rdatum->dominates, i, TRUE);
		}
		for (i = ebitmap_startbit(&rdp->types); 
			i < ebitmap_length(&rdp->types); i++)	
		{
			if (ebitmap_get_bit(&rdp->types, i))
				ebitmap_set_bit(&rdatum->types, i, TRUE);
		}		
	}

	/* go through all the roles */
	return 0;
}

static role_datum_t *
 define_role_dom(role_datum_t * r)
{
	role_datum_t *role;
	char *role_id;
	unsigned int i;
	int ret;

	if (pass == 1) {
		role_id = queue_remove(id_queue);
		free(role_id);
		return (role_datum_t *)1; /* any non-NULL value */
	}

	role_id = queue_remove(id_queue);
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       role_id);
	if (!role) {
		role = (role_datum_t *) malloc(sizeof(role_datum_t));
		if (!role) {
			yyerror("out of memory");
			free(role_id);
			return NULL;
		}
		memset(role, 0, sizeof(role_datum_t));
		role->value = ++policydbp->p_roles.nprim;
		ebitmap_set_bit(&role->dominates, role->value-1, TRUE);
		ret = hashtab_insert(policydbp->p_roles.table,
				     (hashtab_key_t) role_id, (hashtab_datum_t) role);

		if (ret) {
			yyerror("hash table overflow");
			free(role);
			free(role_id);
			return NULL;
		}
	}
	if (r) {
		for (i = ebitmap_startbit(&r->dominates); i < ebitmap_length(&r->dominates); i++) {
			if (ebitmap_get_bit(&r->dominates, i))
				ebitmap_set_bit(&role->dominates, i, TRUE);
		}
		for (i = ebitmap_startbit(&r->types); i < ebitmap_length(&r->types); i++)	{
			if (ebitmap_get_bit(&r->types, i))
				ebitmap_set_bit(&role->types, i, TRUE);
		}
		if (!r->value) {
			/* free intermediate result */
			ebitmap_destroy(&r->types);
			ebitmap_destroy(&r->dominates);
			free(r);
		}
		/*
		 * Now go through all the roles and escalate this role's
		 * dominates and types if a role dominates this role.
		 */
		hashtab_map(policydbp->p_roles.table,
						dominate_role_recheck, role);
	}
	return role;
}


static int set_roles(ebitmap_t *set,
		     char *id)
{
	role_datum_t *r;
	unsigned int i;

	if (strcmp(id, "*") == 0) {
		/* set all roles */
		for (i = 0; i < policydbp->p_roles.nprim; i++) 
			ebitmap_set_bit(set, i, TRUE);
		free(id);
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		/* complement the set */
		for (i = 0; i < policydbp->p_roles.nprim; i++) {
			if (ebitmap_get_bit(set, i))
				ebitmap_set_bit(set, i, FALSE);
			else 
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		sprintf(errormsg, "unknown role %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	/* set one role */
	ebitmap_set_bit(set, r->value - 1, TRUE);
	free(id);
	return 0;
}


static int define_role_trans(void)
{
	char *id;
	role_datum_t *role;
	ebitmap_t roles, types, negset;
	struct role_trans *tr = 0;
	unsigned int i, j;
	int add = 1;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		id = queue_remove(id_queue);
		free(id);
		return 0;
	}

	ebitmap_init(&roles);
	ebitmap_init(&types);

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&roles, id))
			return -1;
	}

	ebitmap_init(&negset);
	while ((id = queue_remove(id_queue))) {
		if (set_types(&types, &negset, id, &add))
			return -1;
	}
	ebitmap_destroy(&negset);

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no new role in transition definition?");
		goto bad;
	}
	role = hashtab_search(policydbp->p_roles.table, id);
	if (!role) {
		sprintf(errormsg, "unknown role %s used in transition definition", id);
		yyerror(errormsg);
		goto bad;
	}

	for (i = ebitmap_startbit(&roles); i < ebitmap_length(&roles); i++) {
		if (!ebitmap_get_bit(&roles, i)) 
			continue;
		for (j = ebitmap_startbit(&types); j < ebitmap_length(&types); j++) {
			if (!ebitmap_get_bit(&types, j)) 
				continue;

			for (tr = policydbp->role_tr; tr; tr = tr->next) {
				if (tr->role == (i+1) && tr->type == (j+1)) {
					sprintf(errormsg, "duplicate role transition defined for (%s,%s)", 
						role_val_to_name(i+1), type_val_to_name(j+1));
					yyerror(errormsg);
					goto bad;
				}
			}

			tr = malloc(sizeof(struct role_trans));
			if (!tr) {
				yyerror("out of memory");
				return -1;
			}
			memset(tr, 0, sizeof(struct role_trans));
			tr->role = i+1;
			tr->type = j+1;
			tr->new_role = role->value;
			tr->next = policydbp->role_tr;
			policydbp->role_tr = tr;
		}
	}

	return 0;

 bad:
	return -1;
}


static int define_role_allow(void)
{
	char *id;
	ebitmap_t roles, new_roles;
	struct role_allow *ra = 0;
	unsigned int i, j;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	ebitmap_init(&roles);
	ebitmap_init(&new_roles);

	while ((id = queue_remove(id_queue))) {
		if (set_roles(&roles, id))
			return -1;
	}


	while ((id = queue_remove(id_queue))) {
		if (set_roles(&new_roles, id))
			return -1;
	}

	for (i = ebitmap_startbit(&roles); i < ebitmap_length(&roles); i++) {
		if (!ebitmap_get_bit(&roles, i)) 
			continue;
		for (j = ebitmap_startbit(&new_roles); j < ebitmap_length(&new_roles); j++) {
			if (!ebitmap_get_bit(&new_roles, j)) 
				continue;

			for (ra = policydbp->role_allow; ra; ra = ra->next) {
				if (ra->role == (i+1) && ra->new_role == (j+1))
					break;
			}

			if (ra) 
				continue;

			ra = malloc(sizeof(struct role_allow));
			if (!ra) {
				yyerror("out of memory");
				return -1;
			}
			memset(ra, 0, sizeof(struct role_allow));
			ra->role = i+1;
			ra->new_role = j+1;
			ra->next = policydbp->role_allow;
			policydbp->role_allow = ra;
		}
	}

	return 0;
}


static int define_constraint(constraint_expr_t * expr)
{
	struct constraint_node *node;
	char *id;
	class_datum_t *cladatum;
	perm_datum_t *perdatum;
	ebitmap_t classmap;
	constraint_expr_t *e;
	unsigned int i;
	int depth;

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
		while ((id = queue_remove(id_queue))) 
			free(id);
		return 0;
	}

	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case CEXPR_NOT:
			if (depth < 0) {
				yyerror("illegal constraint expression");
				return -1;
			}
			break;
		case CEXPR_AND:
		case CEXPR_OR:
			if (depth < 1) {
				yyerror("illegal constraint expression");
				return -1;
			}
			depth--;
			break;
		case CEXPR_ATTR:
		case CEXPR_NAMES:
			if (depth == (CEXPR_MAXDEPTH-1)) {
				yyerror("constraint expression is too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal constraint expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal constraint expression");
		return -1;
	}

	ebitmap_init(&classmap);
	while ((id = queue_remove(id_queue))) {
		cladatum = (class_datum_t *) hashtab_search(policydbp->p_classes.table,
						     (hashtab_key_t) id);
		if (!cladatum) {
			sprintf(errormsg, "class %s is not defined", id);
			ebitmap_destroy(&classmap);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		if (ebitmap_set_bit(&classmap, cladatum->value - 1, TRUE)) {
			yyerror("out of memory");
			ebitmap_destroy(&classmap);
			free(id);
			return -1;
		}
		node = malloc(sizeof(struct constraint_node));
		if (!node) {
			yyerror("out of memory");
			return -1;
		}
		memset(node, 0, sizeof(constraint_node_t));
		node->expr = expr;
		node->permissions = 0;

		node->next = cladatum->constraints;
		cladatum->constraints = node;

		free(id);
	}

	while ((id = queue_remove(id_queue))) {
		for (i = ebitmap_startbit(&classmap); i < ebitmap_length(&classmap); i++) {
			if (ebitmap_get_bit(&classmap, i)) {
				cladatum = policydbp->class_val_to_struct[i];
				node = cladatum->constraints;

				perdatum = (perm_datum_t *) hashtab_search(cladatum->permissions.table,
						     (hashtab_key_t) id);
				if (!perdatum) {
					if (cladatum->comdatum) {
						perdatum = (perm_datum_t *) hashtab_search(cladatum->comdatum->permissions.table,
						     (hashtab_key_t) id);
					}
					if (!perdatum) {
						sprintf(errormsg, "permission %s is not defined", id);
						yyerror(errormsg);
						free(id);
						ebitmap_destroy(&classmap);
						return -1;
					}
				}
				node->permissions |= (1 << (perdatum->value - 1));
			}
		}
		free(id);
	}

	ebitmap_destroy(&classmap);

	return 0;
}

static uintptr_t
 define_cexpr(uint32_t expr_type, uintptr_t arg1, uintptr_t arg2)
{
	struct constraint_expr *expr, *e1 = NULL, *e2;
	user_datum_t *user;
	role_datum_t *role;
	ebitmap_t negset;
	char *id;
	uint32_t val;
	int add = 1;

	if (pass == 1) {
		if (expr_type == CEXPR_NAMES) {
			while ((id = queue_remove(id_queue))) 
				free(id);
		}
		return 1; /* any non-NULL value */
	}

	expr = malloc(sizeof(struct constraint_expr));
	if (!expr) {
		yyerror("out of memory");
		return 0;
	}
	memset(expr, 0, sizeof(constraint_expr_t));
	expr->expr_type = expr_type;

	switch (expr_type) {
	case CEXPR_NOT:
		e1 = NULL;
		e2 = (struct constraint_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			free(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_AND:
	case CEXPR_OR:
		e1 = NULL;
		e2 = (struct constraint_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			free(expr);
			return 0;
		}
		e1->next = (struct constraint_expr *) arg2;

		e1 = NULL;
		e2 = (struct constraint_expr *) arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal constraint expression");
			free(expr);
			return 0;
		}
		e1->next = expr;
		return arg1;
	case CEXPR_ATTR:
		expr->attr = arg1;
		expr->op = arg2;
		return (uintptr_t)expr;
	case CEXPR_NAMES:
		expr->attr = arg1;
		expr->op = arg2;
		ebitmap_init(&negset);
		while ((id = (char *) queue_remove(id_queue))) {
			if (expr->attr & CEXPR_USER) {
				user = (user_datum_t *) hashtab_search(policydbp->p_users.table,
								       (hashtab_key_t) id);
				if (!user) {
					sprintf(errormsg, "unknown user %s", id);
					yyerror(errormsg);
					free(expr);
					return 0;
				}
				val = user->value;
			} else if (expr->attr & CEXPR_ROLE) {
				role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
								       (hashtab_key_t) id);
				if (!role) {
					sprintf(errormsg, "unknown role %s", id);
					yyerror(errormsg);
					free(expr);
					return 0;
				}
				val = role->value;
			} else if (expr->attr & CEXPR_TYPE) {
				if (set_types(&expr->names, &negset, id, &add)) {
					free(expr);
					return 0;
				}
				continue;
			} else {
				yyerror("invalid constraint expression");
				free(expr);
				return 0;
			}
			if (ebitmap_set_bit(&expr->names, val - 1, TRUE)) {
				yyerror("out of memory");
				ebitmap_destroy(&expr->names);
				free(expr);
				return 0;
			}
			free(id);
		}
		ebitmap_destroy(&negset);
		return (uintptr_t)expr;
	default:
		yyerror("invalid constraint expression");
		free(expr);
		return 0;
	}

	yyerror("invalid constraint expression");
	free(expr);
	return 0;
}

static int define_conditional(cond_expr_t *expr, cond_av_list_t *t, cond_av_list_t *f )
{
	cond_expr_t *e;
	cond_node_t *cn, tmp, *cn_new;
	int depth;


	/* expression cannot be NULL */
	if ( !expr) {
		yyerror("illegal conditional expression");
		return -1;
	}
	if (!t) {
		if (!f) {
			yyerror("must have at least one rule");
			return -1;
		}
		/* Invert */
		t = f;
		f = 0;
		expr = define_cond_expr(COND_NOT, expr, 0);
		if (!expr) {
			yyerror("unable to invert");
			return -1;
		}
	}

	/* verify expression */
	depth = -1;
	for (e = expr; e; e = e->next) {
		switch (e->expr_type) {
		case COND_NOT:
			if (depth < 0) {
				yyerror("illegal conditional expression; Bad NOT");
				return -1;
			}
			break;
		case COND_AND:
		case COND_OR:
		case COND_XOR:
		case COND_EQ:
		case COND_NEQ:
			if (depth < 1) {
				yyerror("illegal conditional expression; Bad binary op");
				return -1;
			}
			depth--;
			break;
		case COND_BOOL:
			if (depth == (COND_EXPR_MAXDEPTH-1)) {
				yyerror("conditional expression is like totally too deep");
				return -1;
			}
			depth++;
			break;
		default:
			yyerror("illegal conditional expression");
			return -1;
		}
	}
	if (depth != 0) {
		yyerror("illegal conditional expression");
		return -1;
	}

        /*  use tmp conditional node to partially build new node */
	cn = &tmp;
	cn->expr = expr;
	cn->true_list = t;
	cn->false_list = f;
      
	/* normalize/precompute expression */
	if (cond_normalize_expr(policydbp, cn) < 0) {
		yyerror("problem normalizing conditional expression");
		return -1;
	}

	/* get the existing conditional node, or a new one*/
	cn_new = cond_node_search(policydbp, cn);
	if(cn_new) {
		cond_reduce_insert_list (cn->true_list, &cn_new->true_list, &cn_new->false_list, cn_new->cur_state);
		cond_reduce_insert_list (cn->false_list, &cn_new->false_list, &cn_new->true_list, !cn_new->cur_state);
	} else { 
		yyerror("could not get a conditional node");
		return -1;
	}


	return 0;
}


/*  Set the ENABLE bit and parse_context for each rule and check rules to see if they already exist.
 * Insert rules into the conditional db when appropriate.
 *  
 * new - list of rules to potentially add/insert
 * active - list to add rule to, and address to use as parse_context
 * inactive - opposite rule list in same conditional
 * state - whether rules in new are on or off by default.
 *
 * There are 4 possible conditions for a TYPE_* rule.  Allow rules are always inserted or
 * OR'd with existing allow rules on the same side of the same conditional.
 *
 * 1) Not present anywhere -> add it
 * 2) Already in cond, same side -> warn, replace default in prev rule, delete this rule
 * 3) Just added to opp side -> search again (we may still add this rule)
 * 4) In another conditional (either side) -> warn, delete this rule
 */
static void cond_reduce_insert_list(cond_av_list_t *new, cond_av_list_t **active, cond_av_list_t **inactive, int state)
{
	int add_rule = 1;
	cond_av_list_t *c, *top;
	avtab_ptr_t dup;
	uint32_t old_data = 0, new_data = 0;

	top = c = new; 
	/* loop through all the rules in the list */
	while(c) {

                /* is conditional rule a TYPE_* rule that's already in a conditional? */
                /* [note that we checked to see if it's in the base when we parsed the rule] */
		if ((c->node->datum.specified & AVTAB_TYPE) &&
		    ((dup = avtab_search_node(&policydbp->te_cond_avtab, &c->node->key, c->node->datum.specified & AVTAB_TYPE)) != NULL) ){
			do {
				/* is the rule we found in the current rule list or the equivalent */
				if (dup->parse_context == active) {
					/* change original default */
					switch(c->node->datum.specified & AVTAB_TYPE) {
					case AVTAB_TRANSITION:
						old_data = avtab_transition(&dup->datum);
						new_data = avtab_transition(&c->node->datum);
						avtab_transition(&dup->datum) = new_data;
						break;
					case AVTAB_MEMBER:
						old_data = avtab_member(&dup->datum);
						new_data = avtab_member(&c->node->datum);
						avtab_member(&dup->datum) = new_data;
						break;
					case AVTAB_CHANGE:
						old_data = avtab_change(&dup->datum);
						new_data = avtab_change(&c->node->datum);
						avtab_change(&dup->datum) = new_data;
						break;
					}
					sprintf(errormsg, "duplicate type rule on same side of conditional for (%s, %s:%s); overwrote original default %s with %s",
						type_val_to_name(c->node->key.source_type), 
						type_val_to_name(c->node->key.target_type), 
						policydbp->p_class_val_to_name[c->node->key.target_class],
						type_val_to_name(old_data),
						type_val_to_name(new_data));					
					yywarn(errormsg);
					add_rule = 0;
					break;
				}
				/* if the rule we found is in the opposite rule list that's OK*/
				if (dup->parse_context == inactive) {
					continue;
				} else {
					/* the rule we found must be in another conditional */
					sprintf(errormsg, "discarding conflicting conditional type rule for (%s, %s:%s); may only be in one conditional",
						type_val_to_name(c->node->key.source_type), 
						type_val_to_name(c->node->key.target_type), 
						policydbp->p_class_val_to_name[c->node->key.target_class]);
					yywarn(errormsg);
					add_rule = 0;
					break;
				}
			} while ( (dup = avtab_search_node_next(dup, c->node->datum.specified & AVTAB_TYPE)) != NULL);

		} /* end dealing with TYPE_* rules */
		else if ( (c->node->datum.specified & AVTAB_AV ) &&
		     ((dup = avtab_search_node(&policydbp->te_cond_avtab, &c->node->key, c->node->datum.specified & AVTAB_AV)) != NULL) ){
			do {
				/* we only care if the same AV rule is on the same side of the same conditional */
				if (dup->parse_context == active) {
					/* add to original */
					switch(c->node->datum.specified & AVTAB_AV) {
					case AVTAB_ALLOWED:
						new_data = avtab_allowed(&c->node->datum);
						avtab_allowed(&dup->datum) |= new_data;
						break;
					case AVTAB_AUDITALLOW:
						new_data = avtab_auditallow(&c->node->datum);
						avtab_auditallow(&dup->datum) |= new_data;
						break;
					case AVTAB_AUDITDENY:
						new_data = avtab_auditdeny(&c->node->datum);
						/* Since a '0' in an auditdeny mask represents a 
						 * permission we do NOT want to audit (dontaudit), we use
						 * the '&' operand to ensure that all '0's in the mask
						 * are retained (much unlike the allow and auditallow cases).
						 */
						avtab_auditdeny(&dup->datum) &= new_data;
						break;
					}
					add_rule = 0;
					break;
				}
			} while ( (dup = avtab_search_node_next(dup, c->node->datum.specified & AVTAB_AV)) != NULL);
		} /* end dealing with ALLOW rules */

		top = c->next;
		/* Either insert the rule into the policy and active list, or discard the rule */
		if (add_rule) {
			c->node = avtab_insert_with_parse_context(&policydbp->te_cond_avtab, 
								  &c->node->key,
								  &c->node->datum,
								  active);
			/* set whether the rule is enabled/disabled */
			if (state) {
				c->node->datum.specified |= AVTAB_ENABLED;
			} else {
				c->node->datum.specified &= ~AVTAB_ENABLED;
			}

			/* prepend new rule to active list */
 			c->next = *active; 
 			*active = c; 
		} else {
			/* discard rule */
			free(c->node);
			free(c);
			
			add_rule = 1;
		}
                /* next rule */
		c = top;
		
	} /* while */
}

static cond_expr_t *
 define_cond_expr(uint32_t expr_type, void* arg1, void* arg2)
{
	struct cond_expr *expr, *e1 = NULL, *e2;
	cond_bool_datum_t *bool_var;
	char *id;

	/* expressions are handled in the second pass */
	if (pass == 1) {
		if (expr_type == COND_BOOL) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
		}
		return (cond_expr_t *)1; /* any non-NULL value */
	}

	/* create a new expression struct */
	expr = malloc(sizeof(struct cond_expr));
	if (!expr) {
		yyerror("out of memory");
		return NULL;
	}
	memset(expr, 0, sizeof(cond_expr_t));
	expr->expr_type = expr_type;

	/* create the type asked for */
	switch (expr_type) {
	case COND_NOT:
		e1 = NULL;
		e2 = (struct cond_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal conditional NOT expression");
			free(expr);
			return NULL;
		}
		e1->next = expr;
		return (struct cond_expr *) arg1;
	case COND_AND:
	case COND_OR:
	case COND_XOR:
	case COND_EQ:
	case COND_NEQ:
		e1 = NULL;
		e2 = (struct cond_expr *) arg1;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal left side of conditional binary op expression");
			free(expr);
			return NULL;
		}
		e1->next = (struct cond_expr *) arg2;

		e1 = NULL;
		e2 = (struct cond_expr *) arg2;
		while (e2) {
			e1 = e2;
			e2 = e2->next;
		}
		if (!e1 || e1->next) {
			yyerror("illegal right side of conditional binary op expression");
			free(expr);
			return NULL ;
		}
		e1->next = expr;
		return (struct cond_expr *) arg1;
	case COND_BOOL:
		id = (char *) queue_remove(id_queue) ;
		if (!id) {
			yyerror("bad conditional; expected boolean id");
			free(id);
			free(expr);
			return NULL;
		}
		bool_var = (cond_bool_datum_t *) hashtab_search(policydbp->p_bools.table,
								(hashtab_key_t) id);
		if (!bool_var) {
			sprintf(errormsg, "unknown boolean %s in conditional expression", id);
			yyerror(errormsg);
			free(expr);
			free(id);
			return NULL ;
		}
		expr->bool = bool_var->value;
		free(id);
		return expr;
	default:
		yyerror("illegal conditional expression");
		return NULL;
	}
}


static int set_user_roles(ebitmap_t *set,
			  char *id)
{
	role_datum_t *r;
	unsigned int i;

	if (strcmp(id, "*") == 0) {
		/* set all roles */
		for (i = 0; i < policydbp->p_roles.nprim; i++) 
			ebitmap_set_bit(set, i, TRUE);
		free(id);
		return 0;
	}

	if (strcmp(id, "~") == 0) {
		/* complement the set */
		for (i = 0; i < policydbp->p_roles.nprim; i++) {
			if (ebitmap_get_bit(set, i))
				ebitmap_set_bit(set, i, FALSE);
			else 
				ebitmap_set_bit(set, i, TRUE);
		}
		free(id);
		return 0;
	}

	r = hashtab_search(policydbp->p_roles.table, id);
	if (!r) {
		sprintf(errormsg, "unknown role %s", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}

	/* set the role and every role it dominates */
	for (i = ebitmap_startbit(&r->dominates); i < ebitmap_length(&r->dominates); i++) {
		if (ebitmap_get_bit(&r->dominates, i))
			ebitmap_set_bit(set, i, TRUE);
	}
	free(id);
	return 0;
}


static int define_user(void)
{
	char *id;
	user_datum_t *usrdatum;
	int ret;
#ifdef CONFIG_SECURITY_SELINUX_MLS
	mls_range_list_t *rnode;
	level_datum_t *levdatum;
	cat_datum_t *catdatum;
	int relation, l;
	char *levid;
#endif

	if (pass == 1) {
		while ((id = queue_remove(id_queue))) 
			free(id);
#ifdef CONFIG_SECURITY_SELINUX_MLS
		while ((id = queue_remove(id_queue))) { 
			free(id);
			for (l = 0; l < 2; l++) {
				while ((id = queue_remove(id_queue))) { 
					free(id);
				}
			}
		}
#endif
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no user name for user definition?");
		return -1;
	}
	usrdatum = (user_datum_t *) hashtab_search(policydbp->p_users.table,
						   (hashtab_key_t) id);
	if (!usrdatum) {
		usrdatum = (user_datum_t *) malloc(sizeof(user_datum_t));
		if (!usrdatum) {
			yyerror("out of memory");
			free(id);
			return -1;
		}
		memset(usrdatum, 0, sizeof(user_datum_t));
		usrdatum->value = ++policydbp->p_users.nprim;
		ebitmap_init(&usrdatum->roles);
		ret = hashtab_insert(policydbp->p_users.table,
				     (hashtab_key_t) id, (hashtab_datum_t) usrdatum);
		if (ret) {
			yyerror("hash table overflow");
			free(usrdatum);
			free(id);
			return -1;
		}
	} else
		free(id);

	while ((id = queue_remove(id_queue))) {
		if (set_user_roles(&usrdatum->roles, id))
			continue;
	}

#ifdef CONFIG_SECURITY_SELINUX_MLS
	id = queue_remove(id_queue);
	if (!id) {
		rnode = (mls_range_list_t *) malloc(sizeof(mls_range_list_t));
		if (!rnode) {
			yyerror("out of memory");
			free(id);
			return -1;
		}
		memset(rnode, 0, sizeof(mls_range_list_t));
		levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
							    (hashtab_key_t) "unclassified");
		if (!levdatum) {
			yyerror("no range for user");
			return -1;
		}
		rnode->range.level[0].sens = levdatum->level->sens;
		rnode->range.level[1].sens = levdatum->level->sens;
		rnode->next = usrdatum->ranges;
		usrdatum->ranges = rnode;
		goto skip_mls;
	} 
	do {
		rnode = (mls_range_list_t *) malloc(sizeof(mls_range_list_t));
		if (!rnode) {
			yyerror("out of memory");
			free(id);
			return -1;
		}
		memset(rnode, 0, sizeof(mls_range_list_t));

		for (l = 0; l < 2; l++) {
			levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
			if (!levdatum) {
				sprintf(errormsg, "unknown sensitivity %s used in user range definition", id);
				yyerror(errormsg);
				free(rnode);
				free(id);
				continue;
			}
			rnode->range.level[l].sens = levdatum->level->sens;
			ebitmap_init(&rnode->range.level[l].cat);

			levid = id;

			while ((id = queue_remove(id_queue))) {
				catdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
						     (hashtab_key_t) id);
				if (!catdatum) {
					sprintf(errormsg, "unknown category %s used in user range definition", id);
					yyerror(errormsg);
					free(id);
					continue;
				}
				if (!(ebitmap_get_bit(&levdatum->level->cat, catdatum->value - 1))) {
					sprintf(errormsg, "category %s cannot be associated with level %s", id, levid);
					yyerror(errormsg);
					free(id);
					continue;
				}
				if (ebitmap_set_bit(&rnode->range.level[l].cat, catdatum->value - 1, TRUE)) {
					yyerror("out of memory");
					free(id);
					free(levid);
					ebitmap_destroy(&rnode->range.level[l].cat);
					free(rnode);
					return -1;
				}

				/*
				 * no need to keep category name
				 */
				free(id);
			}

			/*
			 * no need to keep sensitivity name
			 */
			free(levid);

			id = queue_remove(id_queue);
			if (!id)
				break;
		}

		if (l == 0) {
			rnode->range.level[1].sens = rnode->range.level[0].sens;
			if (ebitmap_cpy(&rnode->range.level[1].cat, &rnode->range.level[0].cat)) {
				yyerror("out of memory");
				free(id);
				ebitmap_destroy(&rnode->range.level[0].cat);
				free(rnode);
				return -1;
			}
		}
		relation = mls_level_relation(rnode->range.level[1], rnode->range.level[0]);
		if (!(relation & (MLS_RELATION_DOM | MLS_RELATION_EQ))) {
			/* high does not dominate low */
			yyerror("high does not dominate low");
			ebitmap_destroy(&rnode->range.level[0].cat);
			ebitmap_destroy(&rnode->range.level[1].cat);
			free(rnode);
			return -1;
		}
		rnode->next = usrdatum->ranges;
		usrdatum->ranges = rnode;
	} while ((id = queue_remove(id_queue)));
skip_mls:
#endif

	return 0;
}


static int parse_security_context(context_struct_t * c)
{
	char *id;
	role_datum_t *role;
	type_datum_t *typdatum;
	user_datum_t *usrdatum;
#ifdef CONFIG_SECURITY_SELINUX_MLS
	char *levid;
	level_datum_t *levdatum;
	cat_datum_t *catdatum;
	int l;
#endif

	if (pass == 1) {
		id = queue_remove(id_queue); free(id); /* user  */
		id = queue_remove(id_queue); free(id); /* role  */
		id = queue_remove(id_queue); free(id); /* type  */
#ifdef CONFIG_SECURITY_SELINUX_MLS
		id = queue_remove(id_queue); free(id); 
		for (l = 0; l < 2; l++) {
			while ((id = queue_remove(id_queue))) {
				free(id);
			}
		}
#endif 
		return 0;
	}

	context_init(c);

	/* extract the user */
	id = queue_remove(id_queue);
	if (!id) {
		yyerror("no effective user?");
		goto bad;
	}
	usrdatum = (user_datum_t *) hashtab_search(policydbp->p_users.table,
						   (hashtab_key_t) id);
	if (!usrdatum) {
		sprintf(errormsg, "user %s is not defined", id);
		yyerror(errormsg);
		free(id);
		goto bad;
	}
	c->user = usrdatum->value;

	/* no need to keep the user name */
	free(id);

	/* extract the role */
	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no role name for sid context definition?");
		return -1;
	}
	role = (role_datum_t *) hashtab_search(policydbp->p_roles.table,
					       (hashtab_key_t) id);
	if (!role) {
		sprintf(errormsg, "role %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->role = role->value;

	/* no need to keep the role name */
	free(id);


	/* extract the type */
	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no type name for sid context definition?");
		return -1;
	}
	typdatum = (type_datum_t *) hashtab_search(policydbp->p_types.table,
						   (hashtab_key_t) id);
	if (!typdatum || typdatum->isattr) {
		sprintf(errormsg, "type %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	c->type = typdatum->value;

	/* no need to keep the type name */
	free(id);

#ifdef CONFIG_SECURITY_SELINUX_MLS
	/* extract the low sensitivity */
	id = (char *) queue_head(id_queue);
	if (!id || strcmp(id, "system_u") == 0 /* hack */) {
		/* No MLS component to the security context.  Try
		   to use a default 'unclassified' value. */
		levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
							    (hashtab_key_t) "unclassified");
		if (!levdatum) {
			yyerror("no sensitivity name for sid context definition?");
			return -1;
		}
		c->range.level[0].sens = levdatum->level->sens;
		c->range.level[1].sens = levdatum->level->sens;
		goto skip_mls;
	}

	id = (char *) queue_remove(id_queue);
	for (l = 0; l < 2; l++) {
		levdatum = (level_datum_t *) hashtab_search(policydbp->p_levels.table,
						     (hashtab_key_t) id);
		if (!levdatum) {
			sprintf(errormsg, "Sensitivity %s is not defined", id);
			yyerror(errormsg);
			free(id);
			return -1;
		}
		c->range.level[l].sens = levdatum->level->sens;

		/* extract low category set */
		levid = id;
		while ((id = queue_remove(id_queue))) {
			catdatum = (cat_datum_t *) hashtab_search(policydbp->p_cats.table,
						     (hashtab_key_t) id);
			if (!catdatum) {
				sprintf(errormsg, "unknown category %s used in initial sid context", id);
				yyerror(errormsg);
				free(levid);
				free(id);
				goto bad;
			}
			if (ebitmap_set_bit(&c->range.level[l].cat,
					     catdatum->value - 1, TRUE)) {
				yyerror("out of memory");
				free(levid);
				free(id);
				goto bad;
			}
			/* no need to keep category name */
			free(id);
		}

		/* no need to keep the sensitivity name */
		free(levid);

		/* extract high sensitivity */
		id = (char *) queue_remove(id_queue);
		if (!id)
			break;
	}

	if (l == 0) {
		c->range.level[1].sens = c->range.level[0].sens;
		if (ebitmap_cpy(&c->range.level[1].cat, &c->range.level[0].cat)) {

			yyerror("out of memory");
			goto bad;
		}
	}
skip_mls:
#endif

	if (!policydb_context_isvalid(policydbp, c)) {
		yyerror("invalid security context");
		goto bad;
	}
	return 0;

      bad:
	context_destroy(c);

	return -1;
}


static int define_initial_sid_context(void)
{
	char *id;
	ocontext_t *c, *head;

	if (pass == 1) {
		id = (char *) queue_remove(id_queue); free(id);
		parse_security_context(NULL);
		return 0;
	}

	id = (char *) queue_remove(id_queue);
	if (!id) {
		yyerror("no sid name for SID context definition?");
		return -1;
	}
	head = policydbp->ocontexts[OCON_ISID];
	for (c = head; c; c = c->next) {
		if (!strcmp(id, c->u.name))
			break;
	}

	if (!c) {
		sprintf(errormsg, "SID %s is not defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	if (c->context[0].user) {
		sprintf(errormsg, "The context for SID %s is multiply defined", id);
		yyerror(errormsg);
		free(id);
		return -1;
	}
	/* no need to keep the sid name */
	free(id);

	if (parse_security_context(&c->context[0]))
		return -1;

	return 0;
}

static int define_fs_context(unsigned int major, unsigned int minor)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) malloc(6);
	if (!newc->u.name) {
		yyerror("out of memory");
		free(newc);
		return -1;
	}
	sprintf(newc->u.name, "%02x:%02x", major, minor);

	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_FS];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate entry for file system %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FS] = newc;

	return 0;
}

static int define_port_context(unsigned int low, unsigned int high)
{
	ocontext_t *newc, *c, *l, *head;
	unsigned int protocol;
	char *id;

	if (pass == 1) {
		id = (char *) queue_remove(id_queue); free(id);
		parse_security_context(NULL);
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	id = (char *) queue_remove(id_queue);
	if (!id) {
		free(newc);
		return -1;
	}
	if ((strcmp(id, "tcp") == 0) || (strcmp(id, "TCP") == 0)) {
		protocol = IPPROTO_TCP;
	} else if ((strcmp(id, "udp") == 0) || (strcmp(id, "UDP") == 0)) {
		protocol = IPPROTO_UDP;
	} else {
		sprintf(errormsg, "unrecognized protocol %s", id);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	newc->u.port.protocol = protocol;
	newc->u.port.low_port = low;
	newc->u.port.high_port = high;

	if (low > high) {
		sprintf(errormsg, "low port %d exceeds high port %d", low, high);
		yyerror(errormsg);
		free(newc);
		return -1;
	}

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}

	/* Preserve the matching order specified in the configuration. */
	head = policydbp->ocontexts[OCON_PORT];
	for (l = NULL, c = head; c; l = c, c = c->next) {
		unsigned int prot2, low2, high2;

		prot2 = c->u.port.protocol;
		low2 = c->u.port.low_port;
		high2 = c->u.port.high_port;
		if (protocol != prot2)
			continue;
		if (low == low2 && high == high2) {
			sprintf(errormsg, "duplicate portcon entry for %s %d-%d ", id, low, high);
			goto bad;
		}
		if (low2 <= low && high2 >= high) {
			sprintf(errormsg, "portcon entry for %s %d-%d hidden by earlier entry for %d-%d", id, low, high, low2, high2);
			goto bad;
		}
	}

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_PORT] = newc;

	return 0;

bad:
	yyerror(errormsg);
	free(newc);
	return -1;
}

static int define_netif_context(void)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}
	if (parse_security_context(&newc->context[1])) {
		context_destroy(&newc->context[0]);
		free(newc->u.name);
		free(newc);
		return -1;
	}
	head = policydbp->ocontexts[OCON_NETIF];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate entry for network interface %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			context_destroy(&newc->context[1]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_NETIF] = newc;
	return 0;
}

static int define_ipv4_node_context(unsigned int addr, unsigned int mask)
{
	ocontext_t *newc, *c, *l, *head;

	if (pass == 1) {
		parse_security_context(NULL);
		return 0;
	}

	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.node.addr = addr;
	newc->u.node.mask = mask;

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		return -1;
	}
	/* Place this at the end of the list, to retain
	   the matching order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE];
	for (l = NULL, c = head; c; l = c, c = c->next);

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE] = newc;

	return 0;
}

static int define_ipv6_node_context(void)
{
	char *id;
	int rc = 0;
	struct in6_addr addr, mask;
	ocontext_t *newc, *c, *l, *head;
	
	if (pass == 1) {
		free(queue_remove(id_queue));
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		goto out;
	}
	
	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &addr);
	free (id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 address");
		if (rc == 0)
			rc = -1;
		goto out;
	}

	id = queue_remove(id_queue);
	if (!id) {
		yyerror("failed to read ipv6 address");
		rc = -1;
		goto out;
	}

	rc = inet_pton(AF_INET6, id, &mask);
	free(id);
	if (rc < 1) {
		yyerror("failed to parse ipv6 mask");
		if (rc == 0)
			rc = -1;
		goto out;
	}
	
	newc = malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		rc = -1;
		goto out;
	}

	memset(newc, 0, sizeof(ocontext_t));
	memcpy(&newc->u.node6.addr[0], &addr.s6_addr32[0], 16);
	memcpy(&newc->u.node6.mask[0], &mask.s6_addr32[0], 16);

	if (parse_security_context(&newc->context[0])) {
		free(newc);
		rc = -1;
		goto out;
	}

	/* Place this at the end of the list, to retain
	   the matching order specified in the configuration. */
	head = policydbp->ocontexts[OCON_NODE6];
	for (l = NULL, c = head; c; l = c, c = c->next);

	if (l)
		l->next = newc;
	else
		policydbp->ocontexts[OCON_NODE6] = newc;

	rc = 0;
out:
	return rc;
}

static int define_fs_use(int behavior)
{
	ocontext_t *newc, *c, *head;

	if (pass == 1) {
		free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) {
		free(newc);
		return -1;
	}
	newc->v.behavior = behavior;
	if (parse_security_context(&newc->context[0])) {
		free(newc->u.name);
		free(newc);
		return -1;
	}

	head = policydbp->ocontexts[OCON_FSUSE];

	for (c = head; c; c = c->next) {
		if (!strcmp(newc->u.name, c->u.name)) {
			sprintf(errormsg, "duplicate fs_use entry for filesystem type %s", newc->u.name);
			yyerror(errormsg);
			context_destroy(&newc->context[0]);
			free(newc->u.name);
			free(newc);
			return -1;
		}
	}

	newc->next = head;
	policydbp->ocontexts[OCON_FSUSE] = newc;
	return 0;
}

static int define_genfs_context_helper(char *fstype, int has_type)
{
	struct genfs *genfs_p, *genfs, *newgenfs;
	ocontext_t *newc, *c, *head, *p;
	char *type = NULL;
	int len, len2;

	if (pass == 1) {
		free(fstype);
		free(queue_remove(id_queue));
		if (has_type)
			free(queue_remove(id_queue));
		parse_security_context(NULL);
		return 0;
	}

	for (genfs_p = NULL, genfs = policydbp->genfs; 
	     genfs; genfs_p = genfs, genfs = genfs->next) {
		if (strcmp(fstype, genfs->fstype) <= 0)
			break;
	}

	if (!genfs || strcmp(fstype, genfs->fstype)) {
		newgenfs = malloc(sizeof(struct genfs));
		if (!newgenfs) {
			yyerror("out of memory");
			return -1;
		}
		memset(newgenfs, 0, sizeof(struct genfs));
		newgenfs->fstype = fstype;
		newgenfs->next = genfs;
		if (genfs_p) 
			genfs_p->next = newgenfs;
		else
			policydbp->genfs = newgenfs;
		genfs = newgenfs;
	}

	newc = (ocontext_t *) malloc(sizeof(ocontext_t));
	if (!newc) {
		yyerror("out of memory");
		return -1;
	}
	memset(newc, 0, sizeof(ocontext_t));

	newc->u.name = (char *) queue_remove(id_queue);
	if (!newc->u.name) 
		goto fail;
	if (has_type) {
		type = (char *) queue_remove(id_queue);
		if (!type) 
			goto fail;
		if (type[1] != 0) {
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
		switch (type[0]) {
		case 'b':
			newc->v.sclass = SECCLASS_BLK_FILE;
			break;
		case 'c':
			newc->v.sclass = SECCLASS_CHR_FILE;
			break;
		case 'd':
			newc->v.sclass = SECCLASS_DIR;
			break;
		case 'p':
			newc->v.sclass = SECCLASS_FIFO_FILE;
			break;
		case 'l':
			newc->v.sclass = SECCLASS_LNK_FILE;
			break;
		case 's':
			newc->v.sclass = SECCLASS_SOCK_FILE;
			break;
		case '-':
			newc->v.sclass = SECCLASS_FILE;
			break;
		default:
			sprintf(errormsg, "invalid type %s", type);
			yyerror(errormsg);
			goto fail;
		}
	}
	if (parse_security_context(&newc->context[0])) 
		goto fail;

	head = genfs->head;

	for (p = NULL, c = head; c; p = c, c = c->next) {
		if (!strcmp(newc->u.name, c->u.name) && 
		    (!newc->v.sclass || !c->v.sclass || newc->v.sclass == c->v.sclass)) {
			sprintf(errormsg, "duplicate entry for genfs entry (%s, %s)", fstype, newc->u.name);
			yyerror(errormsg);
			goto fail;
		}
		len = strlen(newc->u.name);
		len2 = strlen(c->u.name);
		if (len > len2)
			break;
	}

	newc->next = c;
	if (p) 
		p->next = newc;
	else
		genfs->head = newc;
	return 0;
fail:
	if (type)
		free(type);
	context_destroy(&newc->context[0]);
	if (fstype)
		free(fstype);
	if (newc->u.name)
		free(newc->u.name);
	free(newc);
	return -1;
}

static int define_genfs_context(int has_type)
{
	return define_genfs_context_helper(queue_remove(id_queue), has_type);
}

/* FLASK */


#line 5020 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 170 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; } }
break;
case 2:
#line 172 "policy_parse.y"
{ if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   if (pass == 2) { if (policydb_index_others(policydbp, 1)) return -1;} }
break;
case 6:
#line 180 "policy_parse.y"
{if (define_class()) return -1;}
break;
case 9:
#line 186 "policy_parse.y"
{if (define_initial_sid()) return -1;}
break;
case 15:
#line 197 "policy_parse.y"
{if (define_common_perms()) return -1;}
break;
case 18:
#line 203 "policy_parse.y"
{if (define_av_perms(FALSE)) return -1;}
break;
case 19:
#line 205 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 20:
#line 207 "policy_parse.y"
{if (define_av_perms(TRUE)) return -1;}
break;
case 26:
#line 218 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 27:
#line 220 "policy_parse.y"
{if (define_sens()) return -1;}
break;
case 29:
#line 225 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 30:
#line 227 "policy_parse.y"
{if (define_dominance()) return -1;}
break;
case 35:
#line 236 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 36:
#line 238 "policy_parse.y"
{if (define_category()) return -1;}
break;
case 39:
#line 244 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 40:
#line 246 "policy_parse.y"
{if (define_level()) return -1;}
break;
case 46:
#line 257 "policy_parse.y"
{if (define_common_base()) return -1;}
break;
case 49:
#line 263 "policy_parse.y"
{if (define_av_base()) return -1;}
break;
case 50:
#line 265 "policy_parse.y"
{if (define_av_base()) return -1;}
break;
case 53:
#line 271 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 54:
#line 273 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 71:
#line 296 "policy_parse.y"
{ if (define_attrib()) return -1;}
break;
case 72:
#line 299 "policy_parse.y"
{if (define_type(1)) return -1;}
break;
case 73:
#line 301 "policy_parse.y"
{if (define_type(0)) return -1;}
break;
case 74:
#line 304 "policy_parse.y"
{if (define_typealias()) return -1;}
break;
case 77:
#line 310 "policy_parse.y"
{if (define_bool()) return -1;}
break;
case 78:
#line 313 "policy_parse.y"
{ if (insert_id("T",0)) return -1; }
break;
case 79:
#line 315 "policy_parse.y"
{ if (insert_id("F",0)) return -1; }
break;
case 80:
#line 318 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-3].ptr, (cond_av_list_t*)yyvsp[-1].ptr,(cond_av_list_t*) 0) < 0) return -1;  }}
break;
case 81:
#line 320 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-7].ptr,(cond_av_list_t*)yyvsp[-5].ptr,(cond_av_list_t*)yyvsp[-1].ptr) < 0 ) return -1;  }}
break;
case 82:
#line 322 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-6].ptr,(cond_av_list_t*)yyvsp[-4].ptr,(cond_av_list_t*) 0) < 0 ) return -1;  }}
break;
case 83:
#line 324 "policy_parse.y"
{ if (pass == 2) { if (define_conditional((cond_expr_t*)yyvsp[-6].ptr,(cond_av_list_t*) 0,(cond_av_list_t*) yyvsp[-1].ptr) < 0 ) return -1;  }}
break;
case 86:
#line 331 "policy_parse.y"
{ yyval.ptr = yyvsp[-1].ptr;}
break;
case 87:
#line 333 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NOT, yyvsp[0].ptr, 0);
			  if (yyval.ptr == 0) return -1; }
break;
case 88:
#line 336 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_AND, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 89:
#line 339 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_OR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return   -1; }
break;
case 90:
#line 342 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_XOR, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 91:
#line 345 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_EQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 92:
#line 348 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_NEQ, yyvsp[-2].ptr, yyvsp[0].ptr);
			  if (yyval.ptr == 0) return  -1; }
break;
case 93:
#line 351 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 94:
#line 354 "policy_parse.y"
{ yyval.ptr = define_cond_expr(COND_BOOL,0, 0);
			  if (yyval.ptr == COND_ERR) return   -1; }
break;
case 95:
#line 358 "policy_parse.y"
{ yyval.ptr = define_cond_pol_list((cond_av_list_t *) 0, (cond_av_list_t *)yyvsp[0].ptr);}
break;
case 96:
#line 360 "policy_parse.y"
{ yyval.ptr = define_cond_pol_list((cond_av_list_t *)yyvsp[-1].ptr, (cond_av_list_t *)yyvsp[0].ptr); }
break;
case 97:
#line 363 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 98:
#line 365 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 99:
#line 368 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVTAB_TRANSITION) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 100:
#line 371 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVTAB_MEMBER) ;
                          if (yyval.ptr ==  COND_ERR) return -1;}
break;
case 101:
#line 374 "policy_parse.y"
{ yyval.ptr = define_cond_compute_type(AVTAB_CHANGE) ;
                          if (yyval.ptr == COND_ERR) return -1;}
break;
case 102:
#line 378 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 103:
#line 380 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 104:
#line 382 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 105:
#line 384 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 106:
#line 387 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVTAB_ALLOWED) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 107:
#line 391 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVTAB_AUDITALLOW) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 108:
#line 395 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(AVTAB_AUDITDENY) ;
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 109:
#line 399 "policy_parse.y"
{ yyval.ptr = define_cond_te_avtab(-AVTAB_AUDITDENY);
                          if (yyval.ptr == COND_ERR) return -1; }
break;
case 110:
#line 403 "policy_parse.y"
{if (define_compute_type(AVTAB_TRANSITION)) return -1;}
break;
case 111:
#line 405 "policy_parse.y"
{if (define_compute_type(AVTAB_MEMBER)) return -1;}
break;
case 112:
#line 407 "policy_parse.y"
{if (define_compute_type(AVTAB_CHANGE)) return -1;}
break;
case 118:
#line 416 "policy_parse.y"
{if (define_te_avtab(AVTAB_ALLOWED)) return -1; }
break;
case 119:
#line 419 "policy_parse.y"
{if (define_te_avtab(AVTAB_AUDITALLOW)) return -1; }
break;
case 120:
#line 422 "policy_parse.y"
{if (define_te_avtab(AVTAB_AUDITDENY)) return -1; }
break;
case 121:
#line 425 "policy_parse.y"
{if (define_te_avtab(-AVTAB_AUDITDENY)) return -1; }
break;
case 122:
#line 428 "policy_parse.y"
{if (define_te_avtab(-AVTAB_ALLOWED)) return -1; }
break;
case 123:
#line 431 "policy_parse.y"
{if (define_role_types()) return -1;}
break;
case 125:
#line 436 "policy_parse.y"
{if (define_role_trans()) return -1; }
break;
case 126:
#line 439 "policy_parse.y"
{if (define_role_allow()) return -1; }
break;
case 127:
#line 442 "policy_parse.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 128:
#line 444 "policy_parse.y"
{ yyval.ptr = merge_roles_dom((role_datum_t*)yyvsp[-1].ptr, (role_datum_t*)yyvsp[0].ptr); if (yyval.ptr == 0) return -1;}
break;
case 129:
#line 447 "policy_parse.y"
{yyval.ptr = define_role_dom(NULL); if (yyval.ptr == 0) return -1;}
break;
case 130:
#line 449 "policy_parse.y"
{yyval.ptr = define_role_dom((role_datum_t*)yyvsp[-1].ptr); if (yyval.ptr == 0) return -1;}
break;
case 135:
#line 458 "policy_parse.y"
{ if (define_constraint((constraint_expr_t*)yyvsp[-1].valptr)) return -1; }
break;
case 136:
#line 461 "policy_parse.y"
{ yyval.valptr = yyvsp[-1].valptr; }
break;
case 137:
#line 463 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NOT, yyvsp[0].valptr, 0);
			  if (yyval.valptr == 0) return -1; }
break;
case 138:
#line 466 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_AND, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 139:
#line 469 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_OR, yyvsp[-2].valptr, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 140:
#line 472 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 141:
#line 475 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 142:
#line 478 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 143:
#line 481 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, yyvsp[-1].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 144:
#line 483 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 145:
#line 484 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_USER, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 146:
#line 486 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 147:
#line 487 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 148:
#line 489 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 149:
#line 490 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 150:
#line 492 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 151:
#line 493 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 152:
#line 495 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 153:
#line 496 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 154:
#line 498 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 155:
#line 499 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), yyvsp[-2].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 156:
#line 502 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 157:
#line 504 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 158:
#line 505 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 159:
#line 507 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 160:
#line 508 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 161:
#line 511 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, yyvsp[0].valptr);
			  if (yyval.valptr == 0) return -1; }
break;
case 162:
#line 513 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 163:
#line 514 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 164:
#line 516 "policy_parse.y"
{ if (insert_separator(1)) return -1; }
break;
case 165:
#line 517 "policy_parse.y"
{ yyval.valptr = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if (yyval.valptr == 0) return -1; }
break;
case 166:
#line 521 "policy_parse.y"
{ yyval.valptr = CEXPR_EQ; }
break;
case 167:
#line 523 "policy_parse.y"
{ yyval.valptr = CEXPR_NEQ; }
break;
case 168:
#line 526 "policy_parse.y"
{ yyval.valptr = yyvsp[0].valptr; }
break;
case 169:
#line 528 "policy_parse.y"
{ yyval.valptr = CEXPR_DOM; }
break;
case 170:
#line 530 "policy_parse.y"
{ yyval.valptr = CEXPR_DOMBY; }
break;
case 171:
#line 532 "policy_parse.y"
{ yyval.valptr = CEXPR_INCOMP; }
break;
case 176:
#line 541 "policy_parse.y"
{if (define_user()) return -1;}
break;
case 185:
#line 556 "policy_parse.y"
{if (define_initial_sid_context()) return -1;}
break;
case 190:
#line 565 "policy_parse.y"
{if (define_fs_context(yyvsp[-3].val,yyvsp[-2].val)) return -1;}
break;
case 196:
#line 576 "policy_parse.y"
{if (define_port_context(yyvsp[-1].val,yyvsp[-1].val)) return -1;}
break;
case 197:
#line 578 "policy_parse.y"
{if (define_port_context(yyvsp[-3].val,yyvsp[-1].val)) return -1;}
break;
case 202:
#line 587 "policy_parse.y"
{if (define_netif_context()) return -1;}
break;
case 207:
#line 596 "policy_parse.y"
{if (define_ipv4_node_context(yyvsp[-2].val,yyvsp[-1].val)) return -1;}
break;
case 208:
#line 598 "policy_parse.y"
{if (define_ipv6_node_context()) return -1;}
break;
case 211:
#line 604 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
break;
case 212:
#line 606 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
break;
case 213:
#line 608 "policy_parse.y"
{if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
break;
case 218:
#line 617 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 219:
#line 618 "policy_parse.y"
{insert_id("-", 0);}
break;
case 220:
#line 619 "policy_parse.y"
{if (define_genfs_context(1)) return -1;}
break;
case 221:
#line 621 "policy_parse.y"
{if (define_genfs_context(0)) return -1;}
break;
case 222:
#line 624 "policy_parse.y"
{ 
			  unsigned int addr;
	  		  unsigned char *p = ((unsigned char *)&addr);

			  p[0] = yyvsp[-6].val & 0xff;				
			  p[1] = yyvsp[-4].val & 0xff;
			  p[2] = yyvsp[-2].val & 0xff;
			  p[3] = yyvsp[0].val & 0xff;
			  yyval.val = addr;
			}
break;
case 226:
#line 641 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 227:
#line 643 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 228:
#line 646 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 229:
#line 648 "policy_parse.y"
{if (insert_separator(0)) return -1;}
break;
case 234:
#line 658 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 235:
#line 660 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 236:
#line 662 "policy_parse.y"
{ if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 237:
#line 665 "policy_parse.y"
{ if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
break;
case 238:
#line 668 "policy_parse.y"
{ if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
break;
case 239:
#line 670 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 240:
#line 671 "policy_parse.y"
{ if (insert_separator(0)) return -1; }
break;
case 241:
#line 674 "policy_parse.y"
{ if (insert_id("~", 1)) return -1; }
break;
case 242:
#line 677 "policy_parse.y"
{ if (insert_id("*", 1)) return -1; }
break;
case 250:
#line 689 "policy_parse.y"
{ if (insert_id(yytext, 1)) return -1; }
break;
case 257:
#line 698 "policy_parse.y"
{ if (insert_id("-", 0)) return -1; }
break;
case 260:
#line 701 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 261:
#line 704 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 262:
#line 707 "policy_parse.y"
{ if (insert_id(yytext, 1)) return -1; }
break;
case 272:
#line 721 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
case 273:
#line 724 "policy_parse.y"
{ yyval.val = strtoul(yytext,NULL,0); }
break;
case 274:
#line 727 "policy_parse.y"
{ if (insert_id(yytext,0)) return -1; }
break;
#line 5840 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
